#!/usr/bin/perl
@youbi = ('Mon','Tsu','Wed','Thu','Fri','Sat','Sun');
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$year += 1900;
$mon += 1;
$machine = $^O;
$date = "Date: $year/$mon/$mday($youbi[$wday]) $hour:$min:$sec";

print "Operating system: ",$machine,"\n";
print $date,"\n";

################
# Find process #
################
$nsub = 0;
open(IN,"proc.list") || die "cannot open proc.list for reading";
while(<IN>) {
  if (/^\[/) {
    @wds1 = split(/\:+/,$_); 
    @wds2 = split(/\[+/,$wds1[0]);
    @wds3 = split(/\]+/,$wds2[1]);
    if (-d "bbbb/$wds3[0]" || -d "diboson/$wds3[0]" || -d "qcd/$wds3[0]"
        || -d "top/$wds3[0]" || -d "wjets/$wds3[0]" || -d "zjets/$wds3[0]"
        || -d "aajets/$wds3[0]" || -d "ajets/$wds3[0]" ) {
      if (-d "bbbb/$wds3[0]")    { $subproc[$nsub] = "bbbb/$wds3[0]";    }
      if (-d "diboson/$wds3[0]") { $subproc[$nsub] = "diboson/$wds3[0]"; }
      if (-d "qcd/$wds3[0]")     { $subproc[$nsub] = "qcd/$wds3[0]";     }
      if (-d "top/$wds3[0]")     { $subproc[$nsub] = "top/$wds3[0]";     }
      if (-d "wjets/$wds3[0]")   { $subproc[$nsub] = "wjets/$wds3[0]";   }
      if (-d "zjets/$wds3[0]")   { $subproc[$nsub] = "zjets/$wds3[0]";   }
      if (-d "aajets/$wds3[0]")   { $subproc[$nsub] = "aajets/$wds3[0]";   }
      if (-d "ajets/$wds3[0]")   { $subproc[$nsub] = "ajets/$wds3[0]";   }
      $subprocid[$nsub] = $wds3[0];
      print "process: [", $subprocid[$nsub],"] was detected in ",
        $subproc[$nsub]," ...\n";
      $nsub++;
    }
  }
}
close(IN);

#################################
# Fetch environmental variables #
#################################
$pwd = $ENV{'PWD'};
$pdflib = $ENV{'PDFLIB'};
$fc = $ENV{'FC'};
$fflags = $ENV{'FFLAGS'};
$cc = $ENV{'CC'};
$cflags = $ENV{'CFLAGS'};
$cpp = $ENV{'CPP'};
$cppopt = $ENV{'CPPOPT'};
$ldflags = $ENV{'LDFLAGS'};
$ar = $ENV{'AR'};
$pyth_lib = $ENV{'PYTH_LIB'};
$herw_lib = $ENV{'HERW_LIB'};
$herw_inc = $ENV{'HERW_INC'};
$lhapdf_bin = $ENV{'LHAPDF_BIN'};
$lhapdf_lib = $ENV{'LHAPDF_LIB'};
$lhapdf_dat = $ENV{'LHAPDF_DAT'};
$pdflib_lib = $ENV{'PDFLIB_LIB'};
$cern_lib = $ENV{'CERN_LIB'};
$rootlibdir = $ENV{'ROOTLIBDIR'};
$rootincdir = $ENV{'ROOTINCDIR'};

#####################
# Make inc/define.h #
#####################
open(OUT,"> ./inc/define.h");
print OUT <<DEFINE;
#define LHACOMMON   0
#define PYTHIA61   61

#define PYTHIAPDF  1
#define CERNPDFLIB 2
#define LHAPDF     3
#define CTEQ6      4

#define PSMODEL LHACOMMON
#define PDFLIB  $pdflib
DEFINE
close(OUT);

#################
# Make Makefile #
#################
$ftname = "Makefile";
open(OUT,">$ftname");

print OUT <<HEADER;
# Make file for GR\@PPA
#     (c)copyright 1990-1999 Minami-Tateya Group, Japan
#-----------------------------------------------------------------------
# Generated at $date
#-----------------------------------------------------------------------
# Execution of the following two commands completes the setup.
# 1. make
# 2. make install
#-----------------------------------------------------------------------
# GR\@PPA directories
GRAPPADIR = \$(PWD)
GRAPPAINCDIR = \$(GRAPPADIR)/inc
GRAPPALIBDIR = \$(GRAPPADIR)/lib
#-----------------------------------------------------------------------
# Build tools
FC = $fc
FFLAGS = $fflags
CC = $cc
CFLAGS = $cflags
LDFLAGS = $ldflags
AR = $ar
#=======================================================================
# Build the libraries
# Do not touch the lines below unless you know what you are doing.
#-----------------------------------------------------------------------
HEADER

print OUT "all\:",$subprocid[0]," ";
if ($nsub > 1) {
    for ($i = 1; $i < $nsub; $i++) {
	print OUT $subprocid[$i]," ";
    }
}
print OUT "baseslib chanellib grcgenlib ffphotolib\n\n";

for ($i = 0; $i < $nsub; $i++) {
  print OUT <<PROCESS;
$subprocid[$i]:$subproc[$i]/Makefile
	(cd $subproc[$i]; cp ./../../inc/define.h ./; \\
         make FC="\${FC}" FFLAGS="\${FFLAGS}"; rm define.h;)
$subproc[$i]/Makefile: Makefile $subproc[$i]/Makefile.templ
	echo "#define $subprocid[$i]" >> ./inc/define2.h
	echo "LIBDIR    = \$(GRAPPALIBDIR)" > $subproc[$i]/Makefile
	echo "GRAPPAINCDIR = \$(GRAPPAINCDIR)" >> $subproc[$i]/Makefile
	cat $subproc[$i]/Makefile.templ >> $subproc[$i]/Makefile
#-----------------------------------------------------------------------
PROCESS
}

print OUT "kinem: grcgenlib ffphotolib\n\n";
print OUT "integ: baseslib chanellib\n\n";
print OUT <<FRAMEWORK;
baseslib:basesv5.1/Makefile
	(cd basesv5.1; make FC="\${FC}" FFLAGS="\${FFLAGS} -I\${GRAPPAINCDIR}"  CC="\${CC}" CFLAGS="\${CFLAGS}")

basesv5.1/Makefile: Makefile basesv5.1/Makefile.templ
	echo "LIBDIR    = \$(GRAPPALIBDIR)" > basesv5.1/Makefile
	cat basesv5.1/Makefile.templ >> basesv5.1/Makefile

chanellib:chanel/Makefile
	(cd chanel; make FC="\${FC}" FFLAGS="\${FFLAGS}")

chanel/Makefile: Makefile chanel/Makefile.templ
	echo "LIBDIR    = \$(GRAPPALIBDIR)" > chanel/Makefile
	cat chanel/Makefile.templ >> chanel/Makefile

grcgenlib:grckinem/Makefile
	(cd grckinem; cp ./../inc/define.h ./; cp ./../inc/define2.h ./; \\
         make FC="\${FC}" FFLAGS="\${FFLAGS}"; rm -f define.h define2.h;)

grckinem/Makefile: Makefile grckinem/Makefile.templ
	echo "LIBDIR    = \$(GRAPPALIBDIR)" > grckinem/Makefile
	echo "GRAPPAINCDIR = \$(GRAPPAINCDIR)" >> grckinem/Makefile
	cat grckinem/Makefile.templ >> grckinem/Makefile

ffphotolib:ffphoto/Makefile
	(cd ffphoto; make FC="\${FC}" FFLAGS="\${FFLAGS}")

ffphoto/Makefile: Makefile ffphoto/Makefile.templ
	echo "LIBDIR    = \$(GRAPPALIBDIR)" > ffphoto/Makefile
	cat ffphoto/Makefile.templ >> ffphoto/Makefile
#-----------------------------------------------------------------------
FRAMEWORK

print OUT "install:\n";
print OUT "\t(cd basesv5.1; make install)\n";
print OUT "\t(cd chanel; make install)\n";
print OUT "\t(cd grckinem; make install)\n";
print OUT "\t(cd ffphoto; make install)\n";
for ($i = 0; $i < $nsub; $i++) {
  print OUT "\t(cd $subproc[$i]; make install)\n";
}

print OUT "\n";
print OUT "install-kinem:\n";
print OUT "\t(cd grckinem; make install)\n";
print OUT "\t(cd ffphoto; make install)\n";

print OUT "\n";
print OUT "install-integ:\n";
print OUT "\t(cd basesv5.1; make install)\n";
print OUT "\t(cd chanel; make install)\n";

for ($i = 0; $i < $nsub; $i++) {
  print OUT "\n";
  print OUT "install-$subprocid[$i]:\n";
  print OUT "\t(cd $subproc[$i]; make install)\n";
}

print OUT "clean-all:\n";
for ($i = 0; $i < $nsub; $i++) {
  print OUT "\t(cd $subproc[$i]; make clean; rm -f Makefile)\n";
}
print OUT "\t(cd basesv5.1; make clean; rm -f Makefile)\n";
print OUT "\t(cd chanel; make clean; rm -f Makefile)\n";
print OUT "\t(cd grckinem; make clean; rm -f Makefile)\n";
print OUT "\t(cd ffphoto; make clean; rm -f Makefile)\n";
print OUT "\t(cd example; rm -f Makefile.head; rm -f grcpar.F)\n";
print OUT "\t(rm -f ./inc/define2.h)\n";

print OUT "\n";
print OUT "clean-kinem:\n";
print OUT "\t(cd grckinem; make clean; rm -f Makefile)\n";
print OUT "\t(cd ffphoto; make clean; rm -f Makefile)\n";

print OUT "\n";
print OUT "clean-integ:\n";
print OUT "\t(cd basesv5.1; make clean; rm -f Makefile)\n";
print OUT "\t(cd chanel; make clean; rm -f Makefile)\n";

for ($i = 0; $i < $nsub; $i++) {
  print OUT "\n";
  print OUT "clean-$subprocid[$i]:\n";
  print OUT "\t(cd $subproc[$i]; make clean; rm -f Makefile)\n";
}

print OUT "\n";
print OUT "clean-example:\n";
print OUT "\t(cd example; rm -f Makefile.head; rm -f grcpar.F)\n";

print OUT "\n";
print OUT "install-clean:\n";
print OUT "\trm -f \${GRAPPALIBDIR}/*.a\n";

close(OUT);

print "\n";
print "Read process list...\n";
for ($i = 0; $i < $nsub; $i++) { $ichk[$i] = 0; $iscnt[$i] = 0; }
$stat = 0;
open(IN,"proc.list") || die "cannot open proc.list for reading";
while(<IN>) {
  if (/Date/) {
    print "Version : $_ was detected...\n"
  }
  else {
    if (/^\[/) { $stat = 0; $icnt = 0; $ip = -1;}
    if ($stat == 0) {
      for ($i = 0; $i < $nsub; $i++) {
	if (/\[$subprocid[$i]\]/) {
	  $stat = 1; $ichk[$i] = 1; $ip = $i;
	  @wds1 = split(/\:+/,$_);       @wds2 = split(/\s+/,$wds1[1]);
	  @wds3 = split(/\[+/,$wds2[0]); @wds4 = split(/\]+/,$wds3[1]);
	  $maincode[$i] = $wds4[0];
	  print $_;
	}
      }
    }
    elsif ($stat == 1) {
      @swds1 = split(/\[+/,$_);
      if (length($swds1[1]) > 0) {
	@swds2 = split(/\]+/,$swds1[1]);
	$subcode[$ip][$icnt++] = $swds2[0];
	$iscnt[$ip] = $icnt;
	print $_;
      }
    }
  }
}
close(IN);

for ($i = 0; $i < $nsub; $i++) {
  if ($ichk[$i] == 0) {
    print "Error: no [",$subprocid[$i],"] in the table.\n";
    print "The [",$subprocid[$i],"] is not linked in the kinematics library.\n";
    print "Update the latest proc.list .\n";
  }
  else {
    print $maincode[$i]," -> ";
    for ($j = 0; $j < $iscnt[$i]; $j++) {
      print $subcode[$i][$j]," ";
    }
    print "\n";
  }
}

##################
# Make grckorg.F #
##################
open(IN,"./grckinem/grckorg.F.tpl") || die "cannot open grckorg.F for reading";
open(OUT,">kinit.tmp") || die "cannot creat $recfile";
while(<IN>) {
  if (/Add/ && /FUNC/) {
    for ($i = 0; $i < $nsub; $i++) {
      if ($ichk[$i] == 1) {
	print OUT "C+---------------------------------------------------------+\n";
	print OUT "#ifdef $subprocid[$i]\n";
	print OUT "      if (igsub.eq.$maincode[$i]) then\n";
	print OUT "         call pl$subprocid[$i](1,0)\n";
	print OUT "      endif\n";
	for ($j = 0; $j <  $iscnt[$i]; $j++) {
	  print OUT "      if (jproc.eq.$subcode[$i][$j]) then\n";
	  print OUT "         if (igsub.eq.$maincode[$i]) jproc = $maincode[$i]\n";
	  print OUT "         func = fnc$subcode[$i][$j](x)\n";
	  print OUT "      endif\n";
	}
	print OUT "#endif\n";
      }
    }
    print OUT "C+---------------------------------------------------------+\n";
    print OUT $_;
  }
  elsif (/Add/ && /SPDETC/) {
    for ($i = 0; $i < $nsub; $i++) {
      if ($ichk[$i] == 1) {
	print OUT "C+---------------------------------------------------------+\n";
	print OUT "#ifdef $subprocid[$i]\n";
	for ($j = 0; $j <  $iscnt[$i]; $j++) {
	  print OUT "      if (igsub.eq.$subcode[$i][$j]) then\n";
	  print OUT "         call grc$subcode[$i][$j]detc(isel)\n";
	  print OUT "      endif\n";
	}
	print OUT "#endif\n";
      }
    }
    print OUT "C+---------------------------------------------------------+\n";
    print OUT $_;
  }
  elsif (/Add/ && /SPDETH/) {
    for ($i = 0; $i < $nsub; $i++) {
      if ($ichk[$i] == 1) {
	print OUT "C+---------------------------------------------------------+\n";
	print OUT "#ifdef $subprocid[$i]\n";
	for ($j = 0; $j <  $iscnt[$i]; $j++) {
	  print OUT "      if (igsub.eq.$subcode[$i][$j]) then\n";
	  print OUT "         call grc$subcode[$i][$j]deth(isel)\n";
	  print OUT "      endif\n";
	}
	print OUT "#endif\n";
      }
    }
    print OUT "C+---------------------------------------------------------+\n";
    print OUT $_;
  }
  elsif (/Add/ && /PROC/) {
    for ($i = 0; $i < $nsub; $i++) {
      if ($ichk[$i] == 1) {
	print OUT "C+---------------------------------------------------------+\n";
	print OUT "#ifdef $subprocid[$i]\n";
	print OUT "      if (igsub.eq.$maincode[$i]) then\n";
	print OUT "         call pl$subprocid[$i](2,isub)\n";
	print OUT "      endif\n";
	for ($j = 0; $j <  $iscnt[$i]; $j++) {
	  print OUT "      if (igsub.eq.$subcode[$i][$j]) then\n";
	  print OUT "         call pl$subprocid[$i](2,isub)\n";
	  print OUT "      endif\n";
	}
	print OUT "#endif\n";
      }
    }
    print OUT "C+---------------------------------------------------------+\n";
    print OUT $_;
  }
  elsif (/Add/ && /KINEM/) {
    for ($i = 0; $i < $nsub; $i++) {
      if ($ichk[$i] == 1) {
	print OUT "C+---------------------------------------------------------+\n";
	print OUT "#ifdef $subprocid[$i]\n";
	print OUT "      if (igsub.eq.$maincode[$i]) then\n";
	print OUT "         call pl$subprocid[$i](3,0)\n";
	print OUT "      endif\n";
	for ($j = 0; $j <  $iscnt[$i]; $j++) {
	  print OUT "      if (igsub.eq.$subcode[$i][$j]) then\n";
	  print OUT "         call pl$subprocid[$i](3,0)\n";
	  print OUT "      endif\n";
	}
	print OUT "#endif\n";
      }
    }
    print OUT "C+---------------------------------------------------------+\n";
    print OUT $_;
  }
  elsif (/Add/ && /XSET/) {
    for ($i = 0; $i < $nsub; $i++) {
      if ($ichk[$i] == 1) {
	print OUT "C+---------------------------------------------------------+\n";
	print OUT "#ifdef $subprocid[$i]\n";
	print OUT "      if (igsub.eq.$maincode[$i]) then\n";
	print OUT "         call pl$subprocid[$i](4,isel)\n";
	print OUT "      endif\n";
	for ($j = 0; $j <  $iscnt[$i]; $j++) {
	  print OUT "      if (igsub.eq.$subcode[$i][$j]) then\n";
	  print OUT "         call pl$subprocid[$i](4,isel)\n";
	  print OUT "      endif\n";
	}
	print OUT "#endif\n";
      }
    }
    print OUT "C+---------------------------------------------------------+\n";
    print OUT $_;
  }
  else {
    print OUT $_;
  }
}
close(IN);
close(OUT);
system("mv kinit.tmp ./grckinem/grckorg.F");

#################
# Make grcpar.F #
#################
open(IN,"./grckinem/grcpar.F.tpl") || die "cannot open grcpar.F.tpl for reading";
open(OUT,">grcpar.tmp") || die "cannot creat grcpar.tmp";
while(<IN>) {
  print OUT $_;
  if (/^C\+=================/) {
    for ($i = 0; $i < $nsub; $i++) {
      open(IN2,"./$subproc[$i]/param.tpl") || die "cannot open ./$subproc[$i]/param.tpl for reading";
      while(<IN2>) {
	print OUT $_;
      }
      close(IN2);
      print OUT "C+================================================\n";
    }
  }
}
close(IN);
close(OUT);
system("mv grcpar.tmp ./example/grcpar.F");

####################################################
# Make header part of the Makefile for executables #
####################################################
open(OUT,"> example/Makefile.head") || die "cannot creat example/Makefile.head";
print OUT <<EXAM1;
#-----------------------------------------------------------------------
#  Header part of the Makefile for sample programs.
#-----------------------------------------------------------------------
# GR\@PPA
GRAPPADIR = $pwd
GRAPPAINCDIR = \$(GRAPPADIR)/inc
GRAPPALIBDIR = \$(GRAPPADIR)/lib
EXAM1

print OUT "GRAPPALIB  = -lgrcpygen -lffphoto ";
for ($i = $nsub; $i > 0 ; $i--) {
    print OUT "-l$subprocid[$i -1] ";
}
print OUT "-lbases -lchanel\n";

##################################
# ROOT library setup for "rbook" #
##################################
open(OUT,"> example/rootlib_setup.sh") || die "cannot creat example/rootlib_setup.sh";
print OUT <<ROOTLIB;
export LD_LIBRARY_PATH=$rootlibdir:\$LD_LIBRARY_PATH
ROOTLIB
close(OUT);

print "done... \n";
print "Next to do: type \"make; make install\".\n";
print "  Go to an example directory of a process after that.\n";
print "  Type \"Config; make\" there, then you get an example program ready to run.\n";

