      program grappa
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INCLUDE 'grchad.inc'

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

      EXTERNAL DRN
      INTEGER IEV,IDUMMY,IGSEC
      DOUBLE PRECISION SUMXSEC,CRAN

C  PSKINI information
      common/PSKfail/ ifail_pskini,nfail_pskini

C...Statement to link the block data; comment out if any trouble.
C      EXTERNAL GRCBLOCKD

      character*80 lhafile

      parameter ( lhcom = 100000 )
      real*4 h
      common /pawc/h(lhcom)
      character*72 flhist
      real*4 weight

C  For di-boson process
      integer ipvec(2),iplep(4),ipneu(4)
      dimension pVV(4)

C-----------------------------------------------------------------------
C  Output hbook file; "*" for no output.
C-----------------------------------------------------------------------
C      flhist= '*'
      flhist= 'hist.hbook'
C-----------------------------------------------------------------------
C  Number of events to generate.
C-----------------------------------------------------------------------
      nevent= 1000
C-----------------------------------------------------------------------
C  Logical unit number for the output event file; 0 for no output.
C-----------------------------------------------------------------------
C      lunwrit= 0
      lunwrit= 20
C-----------------------------------------------------------------------
      if( lunwrit.gt.0 ) then
C  (ASCII file)
         ifmt= 0
         lhafile= 'lhaext_vv1j_matched_asc.dat'
         open(lunwrit,file=lhafile,form='FORMATTED',status='NEW')
C  (binary file)
C         ifmt= 1
C         lhafile= 'lhaext_bin.dat'
C         open(lunwrit,file=lhafile,form='UNFORMATTED',status='NEW')
      endif
C-----------------------------------------------------------------------
C  Book histograms.
C-----------------------------------------------------------------------
      call hlimit(lhcom)

      call hbook1(1,'mass of V$',100,0.,200.,0.)
      call hbook1(2,'pt of V$',100,0.,200.,0.)
      call hbook1(3,'rapidity of V$',100,-10.,10.,0.)
      call hbook1(4,'pt of Z$',100,0.,200.,0.)
      call hbook1(5,'rapidity of Z$',100,-10.,10.,0.)
      call hbook1(6,'pt of W+$',100,0.,200.,0.)
      call hbook1(7,'rapidity of W+$',100,-10.,10.,0.)
      call hbook1(8,'pt of W-$',100,0.,200.,0.)
      call hbook1(9,'rapidity of W-$',100,-10.,10.,0.)

      call hbook1(10,'mass of VV$',100,0.,1000.,0.)
      call hbook1(11,'pt of VV$',100,0.,200.,0.)
      call hbook1(12,'rapidity of VV$',100,-10.,10.,0.)
      call hbook1(13,'pt/Q of VV$',100,0.,2.,0.)

      call hbook1(20,'mass of VV (pos)$',100,0.,1000.,0.)
      call hbook1(21,'pt of VV (pos)$',100,0.,200.,0.)
      call hbook1(22,'rapidity of VV (pos)$',100,-10.,10.,0.)
      call hbook1(23,'pt/Q of VV (pos)$',100,0.,2.,0.)

      call hbook1(30,'mass of VV (neg)$',100,0.,1000.,0.)
      call hbook1(31,'pt of VV (neg)$',100,0.,200.,0.)
      call hbook1(32,'rapidity of VV (neg)$',100,-10.,10.,0.)
      call hbook1(33,'pt/Q of VV (neg)$',100,0.,2.,0.)

      call hbook1(40,'mass of VV; non-rad$',100,0.,1000.,0.)
      call hbook1(41,'pt of VV; non-rad$',100,0.,200.,0.)
      call hbook1(42,'rapidity of VV; non-rad$',100,-10.,10.,0.)
      call hbook1(43,'pt/Q of VV; non-rad$',100,0.,2.,0.)

      call hbook1(50,'mass of VV; rad$',100,0.,1000.,0.)
      call hbook1(51,'pt of VV; rad$',100,0.,200.,0.)
      call hbook1(52,'rapidity of VV; rad$',100,-10.,10.,0.)
      call hbook1(53,'pt/Q of VV; rad$',100,0.,2.,0.)

      call hbook1(60,'num. of charged leptons$',10,0.,10.,0.)
      call hbook1(61,'num. of neutrinos$',10,0.,10.,0.)
      call hbook1(62,'pt of charged leptons$',100,0.,200.,0.)
      call hbook1(63,'eta of charged leptons$',100,-10.,10.,0.)
      call hbook1(64,'pt of l+$',100,0.,200.,0.)
      call hbook1(65,'eta of l+$',100,-10.,10.,0.)
      call hbook1(66,'pt of l-$',100,0.,200.,0.)
      call hbook1(67,'eta of l-$',100,-10.,10.,0.)

      call hbook1(70,'sum-pt of neutrinos$',100,0.,200.,0.)
      call hbook1(71,'dphi btw charged leptons$',20,0.,3.1416,0.)
      call hbook1(72,'deta btw charged leptons$',100,-10.,10.,0.)
      call hbook1(73,'dphi; opp charge$',20,0.,3.1416,0.)
      call hbook1(74,'deta; opp charge$',100,-10.,10.,0.)
      call hbook1(75,'dphi; opp charge; non-reso$',20,0.,3.1416,0.)
      call hbook1(76,'deta; opp charge; non-reso$',100,-10.,10.,0.)
      call hbook1(77,'dphi; same charge$',20,0.,3.1416,0.)
      call hbook1(78,'deta; same charge$',100,-10.,10.,0.)

      call hbook1(80,'eta(l)-y(Z)$',100,-10.,10.,0.)
      call hbook1(81,'eta(l+)-y(Z)$',100,-10.,10.,0.)
      call hbook1(82,'eta(l-)-y(Z)$',100,-10.,10.,0.)
      call hbook1(83,'eta(l)-y(W)$',100,-10.,10.,0.)
      call hbook1(84,'eta(l+)-y(W+)$',100,-10.,10.,0.)
      call hbook1(85,'eta(l-)-y(W-)$',100,-10.,10.,0.)

      call hbook1(100,'Num. of particles$',100,0.,100.,0.)
      call hbook1(101,'Num. of ISR jets$',100,0.,100.,0.)
      call hbook1(102,'Num. of FSR jets$',100,0.,100.,0.)
C-----------------------------------------------------------------------
C...Initialization.
      CALL UPINIT
      call RUPdump

C  Output the header data.
      if( lunwrit.gt.0 ) then
         if( ifmt.eq.0 ) then
            call lhaWritHdAsc(lunwrit)
         elseif( ifmt.eq.1 ) then
            call lhaWritHdBin(lunwrit)
         endif
      endif

C  Sum of the cross sections.
      SUMXSEC = 0.0D0
      DO I = 1,NPRUP
         SUMXSEC = XSECUP(i) + SUMXSEC
      ENDDO

C...Event loop.
      WRITE(*,'(/10X,''########## Start generating events ##########''
     >     )')

      evpos= 0.d0
      evneg= 0.d0

      DO IEV = 1,nevent

C...Event generation.

C  Process selection.
         CRAN = DRN(IDUMMY)*SUMXSEC
         IGSEC = 0
         DO WHILE (CRAN.GT.0.0D0)
            IGSEC = IGSEC + 1
            CRAN = CRAN - XSECUP(IGSEC)
         ENDDO
         IDPRUP = LPRUP(IGSEC)

C  Generation
         CALL UPEVNT

C         IF (IEV.LE.2 .OR. MOD(IEV,100).EQ.0) THEN
         IF (IEV.LE.5) THEN
            WRITE(*,*) ' '
            WRITE(*,*) 'Event# ',IEV
            call EUPdump
         elseif (MOD(IEV,10000).EQ.0) THEN
            WRITE(*,*) 'Event# ',IEV
         ENDIF

C  Event check
         nvec= 0
         nisr= 0
         nfsr= 0
         do i=1,NUP
            idabs= iabs( IDUP(i) )
            if( idabs.eq.23 .or. idabs.eq.24 ) then
               nvec= nvec +1
               if( nvec.le.2 ) ipvec(nvec)= i
            endif
            if( ISTUP(i).eq.1 .and. MOTHUP(1,i).le.2 .and. 
     >           MOTHUP(2,i).eq.0 ) nisr= nisr +1
            if( ISTUP(i).eq.1 .and. MOTHUP(1,i).eq.1 .and. 
     >           MOTHUP(2,i).eq.2 ) nfsr= nfsr +1
         enddo
         if( nvec.ne.2 ) then
            call EUPdump
            print *,'!!! Number of vector bosons not equal to 2 !!!'
            stop
         endif
         call hf1(100,NUP+.5,1.)
         call hf1(101,nisr+.5,1.)
         call hf1(102,nfsr+.5,1.)

C  Output the event data.
         if( lunwrit.gt.0 ) then
            if( ifmt.eq.0 ) then
               call lhaWritEvAsc(lunwrit)
            elseif( ifmt.eq.1 ) then
               call lhaWritEvBin(lunwrit)
            endif
         endif

C  Analysis
         if( XWGTUP.ge.0.d0 ) then
            weight= 1.
            evpos= evpos +1.d0
         else
            weight= -1.
            evneg= evneg +1.d0
         endif

         do i=1,2
            ip= ipvec(i)
            amV= PUP(5,ip)
            ptV= sqrt( PUP(1,ip)**2 +PUP(2,ip)**2 )
            rapV= log( ( PUP(4,ip) +PUP(3,ip) )
     >           /( PUP(4,ip) -PUP(3,ip) ) )/2.d0
            call hf1(1,real(amV),weight)
            call hf1(2,real(ptV),weight)
            call hf1(3,real(rapV),weight)
            if( IDUP(ip).eq.23 ) then
               call hf1(4,real(ptV),weight)
               call hf1(5,real(rapV),weight)
            elseif( IDUP(ip).eq.24 ) then
               call hf1(6,real(ptV),weight)
               call hf1(7,real(rapV),weight)
            elseif( IDUP(ip).eq.-24 ) then
               call hf1(8,real(ptV),weight)
               call hf1(9,real(rapV),weight)
            endif
         enddo

         do i=1,4
            pVV(i)= PUP(i,ipvec(1)) +PUP(i,ipvec(2))
         enddo
         amVV= sqrt( pVV(4)**2 -pVV(3)**2 -pVV(2)**2 -pVV(1)**2 )
         ptVV= sqrt( pVV(1)**2 +pVV(2)**2 )
         rapVV= log( ( pVV(4) +pVV(3) )/( pVV(4) -pVV(3) ) )/2.d0
         rptVV= ptVV/GRCFAQ
         call hf1(10,real(amVV),weight)
         call hf1(11,real(ptVV),weight)
         call hf1(12,real(rapVV),weight)
         call hf1(13,real(rptVV),weight)
         if( weight.gt.0.d0 ) then
            call hf1(20,real(amVV),1.)
            call hf1(21,real(ptVV),1.)
            call hf1(22,real(rapVV),1.)
            call hf1(23,real(rptVV),1.)
         else
            call hf1(30,real(amVV),1.)
            call hf1(31,real(ptVV),1.)
            call hf1(32,real(rapVV),1.)
            call hf1(33,real(rptVV),1.)
         endif

C  Non-radiative or radiative.
         nrad= mod( IDPRUP, 10 )
         if( nrad.eq.0 ) then
            call hf1(40,real(amVV),weight)
            call hf1(41,real(ptVV),weight)
            call hf1(42,real(rapVV),weight)
            call hf1(43,real(rptVV),weight)
         elseif( nrad.eq.1 ) then
            call hf1(50,real(amVV),weight)
            call hf1(51,real(ptVV),weight)
            call hf1(52,real(rapVV),weight)
            call hf1(53,real(rptVV),weight)
         else
            print *,'abnormal process number: ',IDPRUP
            stop
         endif

C  Decay products
         nlep= 0
         nneu= 0
         do i=1,NUP
            idabs= iabs( IDUP(i) )
            if( idabs.eq.11 .or. idabs.eq.13 .or. idabs.eq.15 ) then
               nlep= nlep +1
               if( nlep.le.4 ) iplep(nlep)= i
            elseif( idabs.eq.12 .or. idabs.eq.14 .or. idabs.eq.16 ) then
               nneu= nneu +1
               if( nneu.le.4 ) ipneu(nneu)= i
            endif
         enddo
         call hf1(60,nlep+.5,1.)
         call hf1(61,nneu+.5,1.)

         if( nlep.gt.0 ) then
            do ilep=1,nlep
               ip= iplep(ilep)
               pt= sqrt( PUP(1,ip)**2 +PUP(2,ip)**2 )
               pabs= sqrt( PUP(1,ip)**2 +PUP(2,ip)**2 +PUP(3,ip)**2 )
               eta= log( ( pabs +abs( PUP(3,ip) ) )/pt )
               if( PUP(3,ip).lt.0.d0 ) eta= -eta
               call hf1(62,real(pt),weight)
               call hf1(63,real(eta),weight)
               if( IDUP(ip).lt.0 ) then
                  call hf1(64,real(pt),weight)
                  call hf1(65,real(eta),weight)
               else
                  call hf1(66,real(pt),weight)
                  call hf1(67,real(eta),weight)
               endif
               if( ilep.lt.nlep ) then
                  do ilep1=ilep+1,nlep
                     ip1= iplep(ilep1)
                     pt1= sqrt( PUP(1,ip1)**2 +PUP(2,ip1)**2 )
                     pabs1= sqrt( PUP(1,ip1)**2 +PUP(2,ip1)**2 
     >                    +PUP(3,ip1)**2 )
                     eta1= log( ( pabs1 +abs( PUP(3,ip1) ) )/pt1 )
                     if( PUP(3,ip1).lt.0.d0 ) eta1= -eta1
                     dphi= acos( ( PUP(1,ip)*PUP(1,ip1) 
     >                    +PUP(2,ip)*PUP(2,ip1) )/pt/pt1 )
                     if( IDUP(ip).lt.0 ) then
                        deta= eta -eta1
                     else
                        deta= eta1 -eta
                     endif
                     call hf1(71,real(dphi),weight)
                     call hf1(72,real(deta),weight)
                     if( IDUP(ip)*IDUP(ip1).lt.0 ) then
                        call hf1(73,real(dphi),weight)
                        call hf1(74,real(deta),weight)
                        if( MOTHUP(1,ip).ne.MOTHUP(1,ip1) ) then
                           call hf1(75,real(dphi),weight)
                           call hf1(76,real(deta),weight)
                        endif
                     else
                        call hf1(77,real(dphi),weight)
                        call hf1(78,real(deta),weight)
                     endif
                  enddo
               endif
               ipm= MOTHUP(1,ip)
               if( iabs( IDUP(ipm) ).eq.23 ) then
                  rapV= log( ( PUP(4,ipm) +PUP(3,ipm) )
     >                 /( PUP(4,ipm) -PUP(3,ipm) ) )/2.d0
                  deta= eta -rapV
                  call hf1(80,real(deta),weight)
                  if( IDUP(ip).lt.0 ) then
                     call hf1(81,real(deta),weight)
                  else
                     call hf1(82,real(deta),weight)
                  endif
               elseif( iabs( IDUP(ipm) ).eq.24 ) then
                  rapV= log( ( PUP(4,ipm) +PUP(3,ipm) )
     >                 /( PUP(4,ipm) -PUP(3,ipm) ) )/2.d0
                  deta= eta -rapV
                  call hf1(83,real(deta),weight)
                  if( IDUP(ip).lt.0 ) then
                     call hf1(84,real(deta),weight)
                  else
                     call hf1(85,real(deta),weight)
                  endif
               endif
            enddo
         endif

         if( nneu.gt.0 ) then
            pxneu= 0.d0
            pyneu= 0.d0
            do ineu=1,nneu
               ip= ipneu(ineu)
               pxneu= pxneu +PUP(1,ip)
               pyneu= pyneu +PUP(2,ip)
            enddo
            ptneu= sqrt( pxneu**2 +pyneu**2 )
            call hf1(70,real(ptneu),weight)
         endif

      ENDDO

      WRITE(*,'(/8X,''########## Event generation completed ##########''
     >     )')
      print *,'Total number of failure returns from PSKINI',
     >     nfail_pskini
      print *,'Do not warry unless too large; e.g., more than 1%.'
      print *,''

C  Summary
      print *,' '
      print *,'---------- Summary ----------'
      xabs= SUMXSEC
      print '('' Integrated absolute cross section = '',E12.6,
     >     '' pb'')', xabs
      print '(F10.0,'' positive, and '',F10.0,
     >     '' negative weight events'')', evpos,evneg
      evtot= evpos +evneg
      evdif= evpos -evneg
      rneg= evneg/evtot
      rnegerr= sqrt( ( 1.d0 -rneg )*rneg/evtot )
      print '(F10.0,'' events in total'')', evtot
      print '('' Negative weight fraction = '',F10.6,'' +- '',F10.6)', 
     >     rneg,rnegerr
      xsec= xabs*evdif/evtot
      xerr= xabs * 2.d0*rnegerr
      print '('' True cross section = '',E12.6,'' +-'',E12.6
     >     '' pb'')', xsec,xerr
      print *,'The error does not include the error from BASES/SPRING.'
      print *,'-----------------------------'

C...Histograms.
      call histdo
C
C -- Store histograms.
C
      if( flhist(1:1).NE.'*' ) then
        call hrput(0,flhist,'N')
      endif

      stop
      END
