      PROGRAM Pythia
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

      INTEGER PYK,PYCHGE,PYCOMP
C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Standard PYTHIA commonblocks.
      INTEGER N,NPAD,K
      REAL*8 P,V
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      INTEGER MSTU,MSTJ
      REAL*8 PARU,PARJ
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      INTEGER MDCY,MDME,KFDP
      REAL*8 BRAT
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      INTEGER MSEL,MSELPD,MSUB,KFIN
      REAL*8 CKIN
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      INTEGER MSTP,MSTI
      REAL*8 PARP,PARI
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

      character*80 lhafile

      parameter ( lhcom = 100000 )
      real*4 h
      common /pawc/h(lhcom)
      character*72 flhist
      real*4 weight

C  For di-boson process
      integer ipvec0(2),ipvec(2)
      dimension pVV(4)
C  Decay products
      integer iplep(4),ipneu(4),idlep(4),idneu(4),ivlep(4),ivneu(4)

C-----------------------------------------------------------------------
C  Output hbook file; "*" for no output.
C-----------------------------------------------------------------------
C      flhist= '*'
      flhist= 'hist.hbook'
C-----------------------------------------------------------------------
C  Number of events. 
C-----------------------------------------------------------------------
      NEV = 9999999                 ! Number of events
C-----------------------------------------------------------------------
C  PS/MI choice in Pythia.
C-----------------------------------------------------------------------
C      MSTP(61)  = 0   ! no ISR
C      MSTP(71)  = 0   ! no FSR
C      MSTP(81)  = 0   ! no MI, old PS when PYEVNT called
C      MSTP(81)  = 1   ! MI on, old PS when PYEVNT called (default)
C      MSTP(81)  = 20  ! no MI, new PS (= PYEVNW)
C      MSTP(81)  = 21  ! MI on, new PS (= PYEVNW)
C      MSTP(111) = 0   ! no hadronization
C-----------------------------------------------------------------------
C  Reset the energy-scale factor
C-----------------------------------------------------------------------
C  The default value of PARP(67) for the "old" PS is not suitable.
C  Comment out when the "new" PS is chosen.
      PARP(67)= 1.0    ! ISR energy scale factor for the "old" PS.
      PARP(71)= 1.0    ! FSR energy scale factor.
C-----------------------------------------------------------------------
C   PDF choice
C-----------------------------------------------------------------------
C      mstp(51)= 1         ! CTEQ3L
C      mstp(51)= 4         ! GRV 94L
C      mstp(51)= 7         ! CTEQ5L (default)
C      mstp(51)= 11        ! GRV 92L
C      mstp(51)= 12        ! EHLQ set 1
C      mstp(58)= 5         ! Nr. of flavor in PDF 
C-----------------------------------------------------------------------
C  Initialization
C-----------------------------------------------------------------------
C  UPINIT is called in PYINIT.
      CALL PYINIT('USER',' ',' ',0,0d0)
C-----------------------------------------------------------------------
C  Print out the parameters
C-----------------------------------------------------------------------
C  Basic control
      print *,'PS, multiple-interaction, hadronization:'
      print *,'  mstp(61, 71, 81, 111) =',mstp(61),mstp(71),
     >     mstp(81),mstp(111)
      print *,'PDF choice: mstp(51) =',mstp(51),
     >     ' with NF: mstp(58) =',mstp(58)

C  Energy scale factors
      print *,'Energy scale factors:'
      print '(5X,''parp(67), parp(71) ='',2F10.3)', parp(67),parp(71)

C  Multiple interaction
      print *,'Multiple interaction model: mstp(82) = ',mstp(82)
      print '(5X,''parp(82) ='',F10.3)', parp(82)
      print '(5X,''parp(83), parp(84) ='',2F10.3)', parp(83),parp(84)
      print '(5X,''parp(85), parp(86) ='',2F10.3)', parp(85),parp(86)
      print '(5X,''parp(89), parp(90) ='',2F10.3)', parp(89),parp(90)

C  Primordial kT
      print *,'Primordial kT mode: mstp(91) = ',mstp(91)
      print '(5X,''parp(91), parp(93) = '',2F10.3)',parp(91),parp(93)

C...Book histograms.
      call hlimit(lhcom)

      call hbook1(1,'mass of V$',100,0.,200.,0.)
      call hbook1(2,'pt of V$',100,0.,200.,0.)
      call hbook1(3,'rapidity of V$',100,-10.,10.,0.)
      call hbook1(4,'pt of Z$',100,0.,200.,0.)
      call hbook1(5,'rapidity of Z$',100,-10.,10.,0.)
      call hbook1(6,'pt of W+$',100,0.,200.,0.)
      call hbook1(7,'rapidity of W+$',100,-10.,10.,0.)
      call hbook1(8,'pt of W-$',100,0.,200.,0.)
      call hbook1(9,'rapidity of W-$',100,-10.,10.,0.)

      call hbook1(10,'mass of VV$',100,0.,1000.,0.)
      call hbook1(11,'pt of VV$',100,0.,200.,0.)
      call hbook1(12,'rapidity of VV$',100,-10.,10.,0.)

      call hbook1(20,'mass of VV (pos)$',100,0.,1000.,0.)
      call hbook1(21,'pt of VV (pos)$',100,0.,200.,0.)
      call hbook1(22,'rapidity of VV (pos)$',100,-10.,10.,0.)

      call hbook1(30,'mass of VV (neg)$',100,0.,1000.,0.)
      call hbook1(31,'pt of VV (neg)$',100,0.,200.,0.)
      call hbook1(32,'rapidity of VV (neg)$',100,-10.,10.,0.)

      call hbook1(40,'mass of VV; non-rad$',100,0.,1000.,0.)
      call hbook1(41,'pt of VV; non-rad$',100,0.,200.,0.)
      call hbook1(42,'rapidity of VV; non-rad$',100,-10.,10.,0.)

      call hbook1(50,'mass of VV; rad$',100,0.,1000.,0.)
      call hbook1(51,'pt of VV; rad$',100,0.,200.,0.)
      call hbook1(52,'rapidity of VV; rad$',100,-10.,10.,0.)
 
      call hbook1(60,'num. of charged leptons$',10,0.,10.,0.)
      call hbook1(61,'num. of neutrinos$',10,0.,10.,0.)
      call hbook1(62,'pt of charged leptons$',100,0.,200.,0.)
      call hbook1(63,'eta of charged leptons$',100,-10.,10.,0.)
      call hbook1(64,'pt of l+$',100,0.,200.,0.)
      call hbook1(65,'eta of l+$',100,-10.,10.,0.)
      call hbook1(66,'pt of l-$',100,0.,200.,0.)
      call hbook1(67,'eta of l-$',100,-10.,10.,0.)

      call hbook1(70,'sum-pt of neutrinos$',100,0.,200.,0.)
      call hbook1(71,'dphi btw charged leptons$',20,0.,3.1416,0.)
      call hbook1(72,'deta btw charged leptons$',100,-10.,10.,0.)
      call hbook1(73,'dphi; opp charge$',20,0.,3.1416,0.)
      call hbook1(74,'deta; opp charge$',100,-10.,10.,0.)
      call hbook1(75,'dphi; opp charge; non-reso$',20,0.,3.1416,0.)
      call hbook1(76,'deta; opp charge; non-reso$',100,-10.,10.,0.)
      call hbook1(77,'dphi; same charge$',20,0.,3.1416,0.)
      call hbook1(78,'deta; same charge$',100,-10.,10.,0.)

      call hbook1(80,'eta(l)-y(Z)$',100,-10.,10.,0.)
      call hbook1(81,'eta(l+)-y(Z)$',100,-10.,10.,0.)
      call hbook1(82,'eta(l-)-y(Z)$',100,-10.,10.,0.)
      call hbook1(83,'eta(l)-y(W)$',100,-10.,10.,0.)
      call hbook1(84,'eta(l+)-y(W+)$',100,-10.,10.,0.)
      call hbook1(85,'eta(l-)-y(W-)$',100,-10.,10.,0.)

      call hbook1(100,'Num. of particles$',100,0.,100.,0.)
      call hbook1(101,'Num. of ISR jets$',100,0.,100.,0.)
      call hbook1(102,'Num. of FSR jets$',100,0.,100.,0.)

C  Integrated absolute cross section.
      xabs= 0.d0
      do i=1,NPRUP
         xabs= xabs +XSECUP(i)
      enddo

      evpos= 0.d0
      evneg= 0.d0

C...Event loop.
      DO IEV = 1,NEV

C  Event processing.
C  UPEVNT is called in PYEVNT; then, the PS and decay simulations are done 
C  according the parameter choice.
         CALL PYEVNT
         if( MSTI(51).ne.0 ) then
            print *,'MSTI(51) = ',MSTI(51)
            print *,'-> EOD signal from PYEVNT'
            goto 9000
         endif

         if( IEV.le.2 ) then
            print *,''
            print *,'Event# ',IEV
            CALL PYLIST(1)
         elseif( mod( IEV, 10000 ).eq.0 ) THEN
            print *,'Event# ',IEV
         endif

C  Analysis
C (input data)
         nvec= 0
         nisr= 0
         nfsr= 0
         do i=1,NUP
            idabs= iabs( IDUP(i) )
            if( idabs.eq.23 .or. idabs.eq.24 ) then
               nvec= nvec +1
            endif
            if( ISTUP(i).eq.1 .and. MOTHUP(1,i).le.2 .and. 
     >           MOTHUP(2,i).eq.0 ) nisr= nisr +1
            if( ISTUP(i).eq.1 .and. MOTHUP(1,i).eq.1 .and. 
     >           MOTHUP(2,i).eq.2 ) nfsr= nfsr +1
         enddo
         if( nvec.ne.2 ) then
            call EUPdump
            print *,'!!! Number of vector bosons not equal to 2 !!!'
            stop
         endif
         call hf1(100,NUP+.5,1.)
         call hf1(101,nisr+.5,1.)
         call hf1(102,nfsr+.5,1.)

         if( XWGTUP.ge.0.d0 ) then
            weight= 1.
            evpos= evpos +1.d0
         else
            weight= -1.
            evneg= evneg +1.d0
         endif

C  (after PYTHIA)
C   Prompt vector bosons in the document lines
         ndoc= 0
         nvec= 0
         do i=1,n
            if( K(i,1).ne.21 ) goto 1
            ndoc= i
            if( K(i,3).eq.0 ) then
               idabs= iabs( K(i,2) )
               if( idabs.eq.23 .or. idabs.eq.24 ) then
                  nvec= nvec +1
                  if( nvec.le.2 ) ipvec0(nvec)= i
               endif
            endif
         enddo
 1       continue
         if( nvec.ne.2 ) then
            CALL PYLIST(1)
            print *,'Num. of prompt vector bosons is not 2: ',nvec
            print *,'   ipvec: ',(ipvec0(i),i=1,nvec)
            stop
         endif
C   Find evolved ones.
         do ivec=1,nvec
            ipvec(ivec)= ipvec0(ivec)
         enddo
         do i=ndoc+1,n
            idabs= iabs( K(i,2) )
            if( idabs.eq.23 .or. idabs.eq.24 ) then
               imoth= K(i,3)
               do ivec=1,nvec
                  if( ipvec(ivec).eq.imoth ) then
                     ipvec(ivec)= i
                  endif
               enddo
            endif
         enddo

C   Vector boson properties
         do ivec=1,2
            ip= ipvec(ivec)
            amV= PYP( ip, 5 )
            ptV= PYP( ip, 10 )
            rapV= PYP( ip, 17 )
            call hf1(1,real(amV),weight)
            call hf1(2,real(ptV),weight)
            call hf1(3,real(rapV),weight)
            if( K(ip,2).eq.23 ) then
               call hf1(4,real(ptV),weight)
               call hf1(5,real(rapV),weight)
            elseif( K(ip,2).eq.24 ) then
               call hf1(6,real(ptV),weight)
               call hf1(7,real(rapV),weight)
            elseif( K(ip,2).eq.-24 ) then
               call hf1(8,real(ptV),weight)
               call hf1(9,real(rapV),weight)
            endif
         enddo

C   Diboson properties
         do i=1,4
            pVV(i)= P(ipvec(1),i) +P(ipvec(2),i)
         enddo
         amVV= sqrt( pVV(4)**2 -pVV(3)**2 -pVV(2)**2 -pVV(1)**2 )
         ptVV= sqrt( pVV(1)**2 +pVV(2)**2 )
         rapVV= log( ( pVV(4) +pVV(3) )/( pVV(4) -pVV(3) ) )/2.d0
         call hf1(10,real(amVV),weight)
         call hf1(11,real(ptVV),weight)
         call hf1(12,real(rapVV),weight)
         if( weight.gt.0.d0 ) then
            call hf1(20,real(amVV),1.)
            call hf1(21,real(ptVV),1.)
            call hf1(22,real(rapVV),1.)
         else
            call hf1(30,real(amVV),1.)
            call hf1(31,real(ptVV),1.)
            call hf1(32,real(rapVV),1.)
         endif

C  Non-radiative or radiative.
         nrad= mod( IDPRUP, 10 )
         if( nrad.eq.0 ) then
            call hf1(40,real(amVV),1.)
            call hf1(41,real(ptVV),weight)
            call hf1(42,real(rapVV),1.)
         elseif( nrad.eq.1 ) then
            call hf1(50,real(amVV),1.)
            call hf1(51,real(ptVV),weight)
            call hf1(52,real(rapVV),1.)
         else
            print *,'abnormal process number: ',IDPRUP
            stop
         endif

C   Decay products in the document lines
         nlep= 0
         nneu= 0
         nother= 0
         do i=1,ndoc
            imoth= K(i,3)
            do ivec=1,nvec
               if( imoth.eq.ipvec0(ivec) ) then
                  idabs= iabs( K(i,2) )
                  if( idabs.eq.11 .or. idabs.eq.13 ) then
                     nlep= nlep +1
                     if( nlep.le.4 ) then
                        iplep(nlep)= i
                        idlep(nlep)= K(i,2)
                        ivlep(nlep)= ivec
                     endif
                  elseif( idabs.eq.12 .or. idabs.eq.14 ) then
                     nneu= nneu +1
                     if( nneu.le.4 ) then
                        ipneu(nneu)= i
                        idneu(nneu)= K(i,2)
                        ivneu(nneu)= ivec
                     endif
                  else
                     nother= nother +1
                  endif
               endif
            enddo
         enddo
C   Only for leptonic decays.
         if( nother.gt.0 ) goto 10
         call hf1(60,nlep+.5,1.)
         call hf1(61,nneu+.5,1.)

C   Trace the leptons.
         do i=ndoc+1,n
            idabs= iabs( K(i,2) )
            if( idabs.ge.11 .and. idabs.le.14 ) then
               id= K(i,2)
               imoth= K(i,3)
               if( nlep.gt.0 ) then
                  do ilep=1,nlep
                     if( imoth.eq.iplep(ilep) .and. 
     >                    id.eq.idlep(ilep) ) iplep(ilep)= i
                  enddo
               endif
               if( nneu.gt.0 ) then
                  do ineu=1,nneu
                     if( imoth.eq.ipneu(ineu) .and. 
     >                    id.eq.idneu(ineu) ) ipneu(ineu)= i
                  enddo
               endif
            endif
         enddo

C   Properties of leptons.
         if( nlep.gt.0 ) then
            do ilep=1,nlep
               ip= iplep(ilep)
               pt= PYP( ip, 10 )
               eta= PYP( ip, 19 )
               call hf1(62,real(pt),weight)
               call hf1(63,real(eta),weight)
               if( K(ip,2).lt.0 ) then
                  call hf1(64,real(pt),weight)
                  call hf1(65,real(eta),weight)
               else
                  call hf1(66,real(pt),weight)
                  call hf1(67,real(eta),weight)
               endif
               if( ilep.lt.nlep ) then
                  do ilep1=ilep+1,nlep
                     ip1= iplep(ilep1)
                     pt1= PYP( ip1, 10 )
                     eta1= PYP( ip1, 19 )
                     dphi= acos( ( P(ip,1)*P(ip1,1) 
     >                    +P(ip,2)*P(ip1,2) )/pt/pt1 )
                     if( K(ip,2).lt.0 ) then
                        deta= eta -eta1
                     else
                        deta= eta1 -eta
                     endif
                     call hf1(71,real(dphi),weight)
                     call hf1(72,real(deta),weight)
                     if( K(ip,2)*K(ip1,2).lt.0 ) then
                        call hf1(73,real(dphi),weight)
                        call hf1(74,real(deta),weight)
                        if( ivlep(ilep).ne.ivlep(ilep1) ) then
                           call hf1(75,real(dphi),weight)
                           call hf1(76,real(deta),weight)
                        endif
                     else
                        call hf1(77,real(dphi),weight)
                        call hf1(78,real(deta),weight)
                     endif
                  enddo
               endif
               ipv= ipvec(ivlep(ilep))
               if( K(ipv,2).eq.23 ) then
                  rapV= PYP( ipv, 17 )
                  deta= eta -rapV
                  call hf1(80,real(deta),weight)
                  if( K(ip,2).lt.0 ) then
                     call hf1(81,real(deta),weight)
                  else
                     call hf1(82,real(deta),weight)
                  endif
               elseif( iabs( K(ipv,2) ).eq.24 ) then
                  rapV= PYP( ipv, 17 )
                  deta= eta -rapV
                  call hf1(83,real(deta),weight)
                  if( K(ip,2).lt.0 ) then
                     call hf1(84,real(deta),weight)
                  else
                     call hf1(85,real(deta),weight)
                  endif
               endif
            enddo
         endif

         if( nneu.gt.0 ) then
            pxneu= 0.d0
            pyneu= 0.d0
            do ineu=1,nneu
               ip= ipneu(ineu)
               pxneu= pxneu +P(ip,1)
               pyneu= pyneu +P(ip,2)
            enddo
            ptneu= sqrt( pxneu**2 +pyneu**2 )
            call hf1(70,real(ptneu),weight)
         endif

C...End of loop over events.
 10      continue
      ENDDO

 9000 continue

C...Cross section table.
      CALL PYSTAT(1)

C  Summary
      print *,' '
      print *,'---------- Summary ----------'
      print '('' Integrated absolute cross section = '',E12.6,
     >     '' pb'')', xabs
      print '(F10.0,'' positive, and '',F10.0,
     >     '' negative weight events'')', evpos,evneg
      evtot= evpos +evneg
      evdif= evpos -evneg
      rneg= evneg/evtot
      rnegerr= sqrt( ( 1.d0 -rneg )*rneg/evtot )
      print '(F10.0,'' events in total'')', evtot
      print '('' Negative weight fraction = '',F10.6,'' +- '',F10.6)', 
     >     rneg,rnegerr
      xsec= xabs*evdif/evtot
      xerr= xabs * 2.d0*rnegerr
      print '('' True cross section = '',E12.6,'' +-'',E12.6
     >     '' pb'')', xsec,xerr
      print *,'The error does not include the error from BASES/SPRING.'
      print *,'-----------------------------'

C...Histograms.
      call histdo
C
C -- Store histograms.
C
      if( flhist(1:1).NE.'*' ) then
        call hrput(0,flhist,'N')
      endif

      stop
      END

      SUBROUTINE UPINIT
C  An "LhaExt" version of UPINIT.
C
C  This routine opens a data file, reads in the "run information" from the 
C  header records, and skips siecified number of events.
C  LUNs for the control file and the data file, and other control parameters 
C  must be given in a read-control file named "lharead_control.txt".
C
C  June 8, 2004, S. Odaka (KEK)
      IMPLICIT NONE

      integer lunctl,lundat,ifmt
      common /lharead/lunctl,lundat,ifmt

      character*80 lhactl
      parameter ( lhactl= 'lharead_control.txt' )
      integer lun,idwt,nSkip,iev
      integer lun1,lun2

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

      print *,' '
      print *,'============================== UPINIT =====',
     >     '=================================='

C  Open the control file.
      lun= 10
      call lunfind( lun )
      lunctl= lun
      open(lunctl,file=lhactl,status='OLD')
      print '('' LHA control file opened: LUN = '',I3)',lunctl
      print '(''   file name = '',A80)',lhactl

C  Read the 1st line: LUNs for the control file and the data file.
      read(lunctl,*) lun1,lun2
      if( lun1.ge.1 ) then
         close( lunctl )
         lunctl= lun1
         print '('' LUN for the control file reassigned: LUN = '',
     >        I3)',lunctl
         open(lunctl,file=lhactl,status='OLD')
         read(lunctl,*) lun1
      endif

C  Read the 2nd line: the parameter for the weighting strategy.
      read(lunctl,*) idwt
      print '('' Specified weighting strategy = '',I3)',idwt
      if( idwt.eq.0 ) then
         print *,'   -> no overwrite'
      else
         print *,'   -> overwrite'
      endif

C  Read the 3rd line: number of events to skip.
      read(lunctl,*) nSkip
      print '('' First '',I3,'' events will be skipped.'')',nSkip

C  Open the 1st data file.
      if( lun2.ge.1 ) then
         lundat= lun2
      else
         call lunfind( lun )
         lundat= lun
      endif
      print '('' Input data file: LUN = '',I3)',lundat

      call lhaopen( lunctl, lundat, ifmt, *9 )

C  Update the run information.
      print *,'Read the header record'
      if( ifmt.eq.0 ) then
         call lhaReadHdAsc( lundat, 0 )
      elseif( ifmt.eq.1 ) then
         call lhaReadHdBin( lundat, 0 )
      endif

C  Overwrite the weighting strategy parameter if specified.
      if( idwt.ne.0 ) IDWTUP= idwt
      print '('' -> weighting strategy = '',I3)',IDWTUP

C  Skip specified number of events.
      if( nSkip.gt.0 ) then
         do iev=1,nSkip
            call lhaReadEvnt(lunctl,lundat,ifmt,*8)
         enddo
         print '('' First '',I3,'' events skipped.'')',nSkip
      endif

      print *,'===========================================',
     >     '=================================='

      return

 8    continue
      print *,'End-of-data during the event skip -> stop'
      stop

 9    continue
      print *,'(error) no input-data file given'
      stop

      end

      subroutine lunfind( lun )
      integer lun
      logical lopen

 1    inquire( lun, opened=lopen )
      if( lopen ) then
         lun= lun +1
         goto 1
      endif

      return
      end

      subroutine lhaopen( lunctl, lundat, ifmt, * )

      character*10 filefmt
      character*80 filename

C  Read the information for the 1st data file.
      call lhactlrd( lunctl, filefmt, filename, *9 )
      print '('' New input file: format = '',A10)',filefmt
      print '(''   file name = '',A80)',filename

C  Open the 1st data file.
      if( filefmt(1:3).eq.'asc' ) then
         ifmt= 0
         open(lundat,file=filename,form='FORMATTED',status='OLD')
      elseif( filefmt(1:3).eq.'bin' ) then
         ifmt= 1
         open(lundat,file=filename,form='UNFORMATTED',status='OLD')
      endif

      print *,'   -> successfully opened'

      return

 9    return 1

      end

      subroutine lhactlrd( lunctl, filefmt, filename, * )

      character*10 filefmt
      character*80 filename
      character*80 string

 1    read(lunctl,'(A80)',end=9) string
C      print *,'Input string:'
C      print '(A80)',string

      if( string(1:1).eq.'*' ) goto 1
      if( string(1:4).eq.'end ' .or. string(1:4).eq.'End '
     >     .or. string(1:4).eq.'END ' ) goto 9

      isep= 0
      do i=1,80
         isep= isep +1
         if( string(isep:isep).eq.':' ) goto 2
      enddo
      print *,'LHACTLRD (error): no separator in the control list'
      stop

 2    continue
      filefmt= string(1:isep-1)
      filename= string(isep+1:80)

      return

 9    continue
      print *,'LHACTLRD: end of the control list'
      return 1

      end

      SUBROUTINE UPEVNT
C  An "LhaExt" version of UPEVNT.
C
C  This routine reads in one event from a data file.
C  The actual read action is done by "lhaReadEvnt".
C  The end-of-data of the input is signaled to the calling routine by
C  setting NUP = 0.
C
C  June 8, 2004, S. Odaka (KEK)
      IMPLICIT NONE

      integer lunctl,lundat,ifmt
      common /lharead/lunctl,lundat,ifmt

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

C  Read an event record.
      call lhaReadEvnt(lunctl,lundat,ifmt,*9)

      return

C  No more file to read.
 9    continue
      NUP= 0
      return

      END
