*----+---1---------2---------3---------4---------5---------6---------7-+
      SUBROUTINE QCDPS(Ipro,Ipar,Ib,Escl,Xin ,Weight)
C Input
C Iprot : Beam particle 
C         Ipro=+1  :      protpn
C              -1  : anti-protpn
C Ipatn : Target parton
C         Ipar=(PDG particle ID)
C Ibeam : Beam diretion
C         Ib   =+1  : +Z direction
C              =-1  : -Z direction
C Escl  : Energy scale of PS evolution
C
C Input
C Weight: Weight of this event
*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      IMPLICIT REAL*8(A-H,O-Z)
      include 'qpincl.h'
      COMMON/QPLIST/PLPTN(10,10000),NLPTN(10,10000),NTOP
      data Pmass/0.93827231d0/
*
      Pbeam=sqrt( (Ebeam+Pmass)*(Ebeam-Pmass) )
      Es2=Escl**2
      Ibeam=Ib
      Iproton = Ipro

*check particle ID
      if(Ipar.le.-6 .or. Ipar.ge.22) then
       write(6,*)'QCDPS:  wrong particle ID ',Ipar
       stop
      else
       Iparton=Ipar
       if(Ipar.ne.21)Iparton = Iproton*Ipar
       Ifo=IDconv2(Iparton)
       if(Ifo.eq.999) then
        write(6,*)'QCDPS: wrong partiocle ID ',Ipar
        stop
       end if
      end if
*
      if(Iparton.eq.1 .or. Iparton.eq.2) then
       Gfrac=0.2d0
       Dfrac=0.8d0
       Nwgt= 9
      else
       if(Iparton.eq.21) then
        Gfrac=0.9d0
        Dfrac=0
        Nwgt= 10
       else
        Gfrac=0.3d0
        Dfrac=0.7d0
        Nwgt= 9
       end if
      end if

       if(QPRAND(Idum).lt.Gfrac) then
        Wgt = 1.d0/Gfrac
        ID  = 21
       else
        if(QPRAND(Idum).le.Dfrac) then
         ID = Iparton
         Wgt = 1.d0/(1-Gfrac)/Dfrac
        else
1818     Ifl  = min(QPRAND(Idum)*5+1,5.1d0)
         if(QPRAND(Idum).gt.0.5d0)Ifl=-Ifl
         ID  = IDconv1(Ifl)
         if(ID.eq.Iparton) goto 1818
         Wgt = 1.d0/(1-Gfrac)/(1-Dfrac)*Nwgt
        end if
       end if

      NTOP = NTOP + 1
      L = NTOP
      L0  = L
      PLPTN(1,L) = 1.d0
      PLPTN(2,L) = 0.d0
      PLPTN(3,L) = 0.0D0
      PLPTN(4,L) = 0.0D0
      PLPTN(5,L) = 0.0D0

      PLPTN(8,L) = (Ebeam+Pbeam)/sqrt(2.d0) 
      PLPTN(9,L) = PLPTN(2,L)/2.d0/PLPTN(8,L)
      PLPTN(7,L) = (PLPTN(8,L)+PLPTN(9,L))/sqrt(2.d0)
      PLPTN(6,L) = (PLPTN(8,L)-PLPTN(9,L))/sqrt(2.d0)
      PLPTN(2,L) = Pmass**2
      PLPTN(10,L) = 1.d0

      NLPTN(1,L) = 2212
      NLPTN(2,L) = 0
      NLPTN(3,L) = 1
      NLPTN(4,L) = 1
      NLPTN(5,L) = 3
      NLPTN(6,L) = 1

      NTOP = NTOP + 1
      L = NTOP
      L1  = L
      PLPTN(1,L) = 1.d0
      PLPTN(2,L) = 0.d0
      PLPTN(3,L) = 0.0D0
      PLPTN(4,L) = 0.0D0
      PLPTN(5,L) = 0.0D0

      PLPTN(8,L) = -999
      PLPTN(9,L) = -999
      PLPTN(7,L) = -999
      PLPTN(6,L) = -999
      Ifl  = IDconv2(ID)
      IDF=abs(Ifl)
      PLPTN(2,L) =-Q2PDF(IDF)
      PLPTN(10,L) = -999
      NLPTN(1,L) = ID
      NLPTN(2,L) =  1
      NLPTN(5,L) =  0
      NLPTN(6,L) = -1

      NAD = NTOP
2     CONTINUE
      IF( NLPTN(5,NAD) .EQ. 0) THEN
       CALL QPGEN1(NAD)
      ENDIF
      NAD = NAD + 1
      IF( NAD .LE. NTOP) GOTO 2

      X0 = Xin
      CALL QPXfix(L1,X0, WgtBr,Idiag)
      Weight=Wgt*WgtBr
* 20/OCt./2003
      IparPS=NLPTN(1,NTOP-1)
c     if(IparPS.eq.21 .and. Idiag.eq.1)Weight=Weight*2
C      if(Ipar.ne.21) then
      if(Iparton.ne.21) then
       if(IparPS.ne.21 .and. Idiag.ne.1) then
C        NLPTN(1,NTOP-1)= Ipar
        NLPTN(1,NTOP-1)= Iparton
        Weight=Weight/10.d0
        if(NLPTN(1,NTOP).eq.-IparPS) then
C         NLPTN(1,NTOP)  =-Ipar
         NLPTN(1,NTOP)  =-Iparton
        end if
C        do 1616 I=NTOP-2,1,-1
C         if(NLPTN(3,I).eq.0 .and. NLPTN(6,I).eq. 1
C     .      .and. NLPTN(1,I).eq.-IparPS            ) then
C          NLPTN(1,I)  =-Ipar
C         end if
C1616    continue
C  2007/7/24 S. Odaka
        i= NTOP -1
 1616   continue
        i= i -NLPTN(2,i)
        if( NLPTN(1,i).eq.IparPS ) then
C           NLPTN(1,i)= Ipar
           NLPTN(1,i)= Iparton
           if( NLPTN(1,i+1).eq.-IparPS ) then
C              NLPTN(1,i+1)= -Ipar
              NLPTN(1,i+1)= -Iparton
           endif
           goto 1616
        endif
       end if
      end if
* 20/OCt./2003
      if(WgtBr.eq.0) return

* skip this to determine the kinematics in PSKINI; S.O.
CCC      CALL QPKINM(L1)

      do 1717 I=L0,NTOP
*Beam direction treatment
       IF(Ibeam .eq. -1) PLPTN(6,I) = - PLPTN(6,I)
*anti-proton treatment
       IF(Iproton.eq.-1.and.NLPTN(1,I).ne.21)NLPTN(1,I)=-NLPTN(1,I)
1717  continue

      RETURN
      END
*----+---1---------2---------3---------4---------5---------6---------7-+
      SUBROUTINE QPGEN1(NAD)
C
      IMPLICIT REAL*8(A-H,O-Z)
      include 'qpincl.h'
      common/qptest/CggF
      COMMON/QPLIST/PLPTN(10,10000),NLPTN(10,10000),NTOP
*
      ID  = NLPTN(1,NAD)
      X   =    PLPTN(1,NAD)
      Q21 =abs(PLPTN(2,NAD))
      Q22 = Es2
*********************** 
* Start Parton Shower *
*********************** 
1     continue
      SDKV21=sudakov(ID,Q22,Q21)
      eta=QPRAND(Idum)
      if(SDKV21.gt.eta) goto 2
*
* Branch!
*
*New Q2 determination
*
      Q21o=Q21
      T1=log(Q21/QCDLd**2)
      if     (ID.eq.21) then
       Ceps=CggF*Cg*(log(1/eps)-11.d0/12.d0)+Tr*2*Nf/3.d0
      else if(ID.ne.21) then
       Ceps=Cf*(2*log(1/eps)- 3.d0/2.d0) 
      end if
      T2=T1*eta**(-beta/2.d0/Ceps)
      Q2out=Exp(T2)*QCDLd**2
*
* Compornent determination
*
      Y2max=1
      Y2min=eps
      if     (ID.ne.21) then
*
* Quark branch part
*
* determination of diagnal branch or not
       fqq=Cf*(2*log(1/eps)-17.d0/6.d0)
       fgq=Cf*                4.d0/3.d0
       if(QPRAND(Idum).lt.fqq/(fqq+fgq)) then
        Idiag=1
       else
        Idiag=0
       end if

       if     (Idiag.eq.1) then
*  Pqq compornent
        LID=ID
        NID=21
       else if(Idiag.eq.0) then
*  Pgq compornent
        LID=21
        NID=ID
       end if
      else if(ID.eq.21) then
*
* Gluon branch part
*
* determination of diagnal branch or not
       fqg=2*Nf*Tr/3.d0
       fgg=CggF*Cg*(log(1/eps)-11.d0/12.d0)
c      Write(6,*)fgg/(fgg+fqg)
       if(QPRAND(Idum).lt.fgg/(fgg+fqg)) then
        Idiag=1
       else
        Idiag=0
       end if

       if(Idiag.eq.0) then
*  Pqg compornent
        LID=MIN(QPRAND(Idum)*Nf+1,Nf*1.01d0)
        if(QPRAND(Idum).gt.0.5d0) LID=-LID
        NID=-LID
       else
*  Pgg compornent
        LID=21
        NID=21
       end if
      end if
      
*Double cascade
c     if(Y2 .LT. Q2out/Es2) then
c      goto 1
c     end 

*
* fill information array
* Leading particle
*
      L = NTOP+1
      PLPTN( 2,L) = -Q2out

      NLPTN(1,L) = LID
      NLPTN(2,L) = L - NAD
      NLPTN(5,L) = 0
      NLPTN(6,L) = -1
      NLPTN(8,L) = Idiag

*
* Non-Leading particle
*
      L = NTOP+2
C      PLPTN( 2,L) = 0
C  1 Aug 2011, S.O.
      PLPTN( 2,L) = Q2out

      NLPTN(1,L) = NID
      NLPTN(2,L) = L - NAD
      NLPTN(3,L) = 0
      NLPTN(5,L) = 1
      NLPTN(6,L) = 1
      NLPTN(8,L) = Idiag

*
* Parent particle
*
      NLPTN(3,NAD) = 2
      NLPTN(4,NAD) = (L-1) - NAD
      NLPTN(5,NAD) = 1

      NTOP = NTOP + 2

      return
*
* end of "Branch" part
***********************************
* not branch
*
2     continue
      NLPTN(3,NAD) = 0
      NLPTN(4,NAD) = 0
      NLPTN(5,NAD) = 1

      return 
      end
*----+---1---------2---------3---------4---------5---------6---------7-+
      SUBROUTINE QPXfix(L0,X0, WgtTOT,Idiag)
      IMPLICIT REAL*8(A-H,O-Z)
      include 'qpincl.h'
* 08/09/2009 fix bug:real variable in array argument
      integer PRT0
      COMMON/QPLIST/PLPTN(10,10000),NLPTN(10,10000),NTOP
*
      WgtTOT = 1
      IF(NTOP.eq.L0) then
       x1 =x0
       Wgt=1
       Idiag= 1  ! added on 13/5/2010 S.O.
       goto 888
      END IF

*
* Case of at least one branch
*

* check upper-bound of X
      OMeps=1
      do 1 NAD=L0+1,NTOP
c      if(NLPTN(6,NAD).eq.-1) then
       if(abs(PLPTN(2,NAD)).gt.1.d-10) then
        eps1=aLmd2/abs(PLPTN(2,NAD))
        eps1=eps
        OMeps = OMeps*(1-eps1)
       end if
1     continue
* Event loop start
      Ibr    = 0
      Xtot   = 1
      Idiag  = 1
      do 2 NAD=L0+1,NTOP
       IF( NLPTN(5,NAD) .EQ. 2)GOTO 2
*
       NPR = NAD - NLPTN(2,NAD)
       L1  = NAD
       L2  = L1 + 1
       ID1 = NLPTN(1,NPR)
       ID2 = NLPTN(1,L1)
       Ins = NLPTN(7,NPR)
*
       Idiag  = Idiag*NLPTN(8,L1)
*
       Ibr = Ibr + 1
*
*New X and Compornent determination
*
       eps1=aLmd2/abs(PLPTN(2,L1))
       eps1=eps
       Y1max=1-eps1
       Y1min=x0/Xtot/OMeps
       if(Y1max.le.Y1min) then
C         write(6,*)' Y1max is less than Y1min ',Y1min,Y1max
        WgtTOT=0
        return
       end if
       Y2max=1-Y1min
       Y2min=eps1
       if     (ID1.ne.21) then
*
* Quark branch part
*
* determination of diagnal branch or not
        if(ID1.eq.ID2) then
*  Pqq compornent
         Y2=Y2min*(Y2max/Y2min)**QPRAND(Idum)
         Y1=1-Y2
         YL =Y1
         YN =Y2
         Ceps=Cf*(2*log(1/eps1)-17.d0/6.d0)
         Wgt=Cf*Y1*(1+Y1**2)*log(Y2max/Y2min)/Ceps 
         Wgt=Wgt/Y1
        else 
*  Pgq compornent
         Y2=Y2min+(Y2max-Y2min)*QPRAND(Idum)
         Y1=1-Y2
         YL =Y1
         YN =Y2
         Ceps=Cf*4.d0/3.d0
         Wgt=Cf*(1+Y2**2)*(Y2max-Y2min)/Ceps 
         Wgt=Wgt/Y1
        end if
       else if(ID1.eq.21) then
*
* Gluon branch part
*
* determination of diagnal branch or not
        if(ID1.ne.ID2) then
*  Pqg compornent
         Y2=Y2min+(Y2max-Y2min)*QPRAND(Idum)
         Y1=1-Y2
         Ceps=Tr/3.d0 
         Wgt=Tr*Y1*(Y1**2+Y2**2)*(Y2max-Y2min)/Ceps
         Wgt=Wgt/Y1
         YL=Y1
         YN=Y2
        else
*  Pgg compornent
         Y2=Y2min*(Y2max/Y2min)**QPRAND(Idum)
         Y1=1-Y2
         Ceps=2*Cg*(log(1/eps1)-11.d0/12.d0)
         Wgt=2*Cg*(Y1**2+Y2**2+(Y1*Y2)**2)*log(Y2max/Y2min)/Ceps
         Wgt=Wgt/Y1
         YL=Y1
         YN=Y2
        end if
       end if
*
       PLPTN( 1,L1) = YL
       PLPTN(10,L1) = Wgt

       PLPTN( 1,L2) = YN
       PLPTN(10,L2) = Wgt
*
       WgtTOT=WgtTOT*Wgt
       Xtot  =Xtot  *YL
       OMeps=OMeps/(1-eps1)
*
       NLPTN(5,L1) = 2
       NLPTN(5,L2) = 2
2     continue
*
* set initial X
*
      X1 =min(1.d0-1.d-10,X0/Xtot)
      Wgt=1.d0/Xtot

888   continue 

      ID =NLPTN(1,L0)
      Ifl = IDconv2(ID)
      IDF=abs(Ifl)
      Qpdf=sqrt(Q2PDF(IDF))
      if(X1.gt.1) then
         write(6,*) 'QPXfix: X1 ',X1
         stop
      end if
C--- Use a GR@PPA utility to set the initial PDF.
C      fPDF=  Ctq5Pdf(Ifl,X1,Qpdf)
      call grcpdf1( ID, X1, Qpdf, fPDF )
      fPDF= fPDF/X1
C---
      Wgt=Wgt*fPDF

      PLPTN( 1,L0) = X1
      PRT0=L0-NLPTN(2,L0)
      PLPTN( 8,L0) = X1*PLPTN(8,PRT0)
      PLPTN(10,L0) = Wgt
      NLPTN( 5,L0) = 2
      WgtTOT=WgtTOT*Wgt
 
      if(L0.eq.NTOP) return
      do 3 NAD=L0+1,NTOP
       NPR = NAD - NLPTN(2,NAD)
       X   = PLPTN(1,NAD)
       PLPTN( 8,NAD) = X*PLPTN(8,NPR)
3     continue

      return
      end
