      program grappa
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

      EXTERNAL DRN
      INTEGER IEV,IDUMMY,IGSEC
      DOUBLE PRECISION SUMXSEC,CRAN

C  PSKINI information
      common/PSKfail/ ifail_pskini,nfail_pskini

C...Statement to link the block data; comment out if any trouble.
C      EXTERNAL GRCBLOCKD

      character*80 lhafile

      parameter ( lhcom = 100000 )
      real*4 h
      common /pawc/h(lhcom)
      character*72 flhist
      real*4 weight

C-----------------------------------------------------------------------
C  Output hbook file; "*" for no output.
C-----------------------------------------------------------------------
C      flhist= '*'
      flhist= 'hist.hbook'
C-----------------------------------------------------------------------
C  Number of events to generate.
C-----------------------------------------------------------------------
      nevent= 1000
C-----------------------------------------------------------------------
C  Logical unit number for the output event file; 0 for no output.
C-----------------------------------------------------------------------
C      lunwrit= 0
      lunwrit= 20
C-----------------------------------------------------------------------
      if( lunwrit.gt.0 ) then
C  (ASCII file)
         ifmt= 0
         lhafile= 'lhaext_w1j_matched_asc.dat'
         open(lunwrit,file=lhafile,form='FORMATTED',status='NEW')
C  (binary file)
C         ifmt= 1
C         lhafile= 'lhaext_bin.dat'
C         open(lunwrit,file=lhafile,form='UNFORMATTED',status='NEW')
      endif
C-----------------------------------------------------------------------
C  Book histograms.
C-----------------------------------------------------------------------
      call hlimit(lhcom)

      call hbook1(1,'mass of V$',100,0.,200.,0.)
      call hbook1(2,'pt of V$',100,0.,200.,0.)
      call hbook1(3,'rapidity of V$',100,-10.,10.,0.)
      call hbook1(4,'pt of V; fine$',100,0.,20.,0.)

      call hbook1(11,'mass of V (pos)$',100,0.,200.,0.)
      call hbook1(12,'pt of V (pos)$',100,0.,200.,0.)
      call hbook1(13,'rapidity of V (pos)$',100,-10.,10.,0.)
      call hbook1(14,'pt of V; fine (pos)$',100,0.,20.,0.)

      call hbook1(21,'mass of V (neg)$',100,0.,200.,0.)
      call hbook1(22,'pt of V (neg)$',100,0.,200.,0.)
      call hbook1(23,'rapidity of V (neg)$',100,-10.,10.,0.)
      call hbook1(24,'pt of V; fine (neg)$',100,0.,20.,0.)

      call hbook1(31,'mass of V; non-rad$',100,0.,200.,0.)
      call hbook1(32,'pt of V; non-rad$',100,0.,200.,0.)
      call hbook1(33,'rapidity of V; non-rad$',100,-10.,10.,0.)
      call hbook1(34,'pt of V; fine; non-rad$',100,0.,20.,0.)

      call hbook1(41,'mass of V; rad$',100,0.,200.,0.)
      call hbook1(42,'pt of V; rad$',100,0.,200.,0.)
      call hbook1(43,'rapidity of V; rad$',100,-10.,10.,0.)
      call hbook1(44,'pt of V; fine; rad$',100,0.,20.,0.)

      call hbook1(51,'rapidity of W+$',100,-10.,10.,0.)
      call hbook1(52,'rapidity of W-$',100,-10.,10.,0.)

      call hbook1(60,'pt of lepton$',100,0.,100.,0.)
      call hbook1(61,'eta of lepton$',100,-10.,10.,0.)
      call hbook1(62,'pt of lepton; non-rad$',100,0.,100.,0.)
      call hbook1(63,'eta of lepton; non-rad$',100,-10.,10.,0.)
      call hbook1(64,'pt of lepton; rad$',100,0.,100.,0.)
      call hbook1(65,'eta of lepton; rad$',100,-10.,10.,0.)
      call hbook1(66,'pt of l+$',100,0.,100.,0.)
      call hbook1(67,'eta of l+$',100,-10.,10.,0.)
      call hbook1(68,'pt of l-$',100,0.,100.,0.)
      call hbook1(69,'eta of l-$',100,-10.,10.,0.)

      call hbook1(70,'pt of neutrino$',100,0.,100.,0.)
      call hbook1(71,'mt (GeV)$',100,0.,200.,0.)
      call hbook1(72,'mt (GeV); non-rad$',100,0.,200.,0.)
      call hbook1(73,'mt (GeV); rad$',100,0.,200.,0.)

      call hbook1(100,'Num. of particles$',100,0.,100.,0.)
      call hbook1(101,'Num. of ISR jets$',100,0.,100.,0.)
      call hbook1(102,'Num. of FSR jets$',100,0.,100.,0.)
C-----------------------------------------------------------------------
C...Initialization.
      CALL UPINIT
      call RUPdump

C  Output the header data.
      if( lunwrit.gt.0 ) then
         if( ifmt.eq.0 ) then
            call lhaWritHdAsc(lunwrit)
         elseif( ifmt.eq.1 ) then
            call lhaWritHdBin(lunwrit)
         endif
      endif

C  Sum of the cross sections.
      SUMXSEC = 0.0D0
      DO I = 1,NPRUP
         SUMXSEC = XSECUP(i) + SUMXSEC
      ENDDO

C...Event loop.
      WRITE(*,'(/10X,''########## Start generating events ##########''
     >     )')

      evpos= 0.d0
      evneg= 0.d0

      DO IEV = 1,nevent

C...Event generation.

C  Process selection.
         CRAN = DRN(IDUMMY)*SUMXSEC
         IGSEC = 0
         DO WHILE (CRAN.GT.0.0D0)
            IGSEC = IGSEC + 1
            CRAN = CRAN - XSECUP(IGSEC)
         ENDDO
         IDPRUP = LPRUP(IGSEC)

C  Generation
         CALL UPEVNT

         if( nevent.le.1000 ) then
            IF (IEV.LE.2 .OR. MOD(IEV,100).EQ.0) THEN
               WRITE(*,*) ' '
               WRITE(*,*) 'Event# ',IEV
               call EUPdump
            ENDIF
         else
            if( iev.le.5 ) then
               WRITE(*,*) ' '
               WRITE(*,*) 'Event# ',IEV
               call EUPdump
            elseif( mod( IEV, 10000 ).eq.0 ) then
               print *,'Event# ',IEV
            endif
         endif

         if( XWGTUP.ge.0.d0 ) then
            weight= 1.
            evpos= evpos +1.d0
         else
            weight= -1.
            evneg= evneg +1.d0
         endif

C  Output the event data.
         if( lunwrit.gt.0 ) then
            if( ifmt.eq.0 ) then
               call lhaWritEvAsc(lunwrit)
            elseif( ifmt.eq.1 ) then
               call lhaWritEvBin(lunwrit)
            endif
         endif

C  Analysis
         ivec= 0
         ilep= 0
         ineu= 0
         nisr= 0
         nfsr= 0
         do i=1,NUP
            idabs= iabs( IDUP(i) )
            if( idabs.eq.24 ) ivec= i
            if( idabs.eq.11 .or. idabs.eq.13 ) ilep= i
            if( idabs.eq.12 .or. idabs.eq.14 ) ineu= i
            if( ISTUP(i).eq.1 .and. MOTHUP(1,i).le.2 .and. 
     >           MOTHUP(2,i).eq.0 ) nisr= nisr +1
            if( ISTUP(i).eq.1 .and. MOTHUP(1,i).eq.1 .and. 
     >           MOTHUP(2,i).eq.2 ) nfsr= nfsr +1
         enddo
         if( ivec.le.0 ) then
            print *,'??? No vector boson found ???'
            stop
         endif
         call hf1(100,NUP+.5,1.)
         call hf1(101,nisr+.5,1.)
         call hf1(102,nfsr+.5,1.)

         amvec= PUP(5,ivec)
         ptvec= sqrt( PUP(1,ivec)**2 +PUP(2,ivec)**2 )
         rapvec= log( ( PUP(4,ivec) +PUP(3,ivec) )
     >             /( PUP(4,ivec) -PUP(3,ivec) ) )/2.d0
         call hf1(1,real(amvec),weight)
         call hf1(2,real(ptvec),weight)
         call hf1(3,real(rapvec),weight)
         call hf1(4,real(ptvec),weight)
         if( weight.ge.0. ) then
            call hf1(11,real(amvec),1.)
            call hf1(12,real(ptvec),1.)
            call hf1(13,real(rapvec),1.)
            call hf1(14,real(ptvec),1.)
         else
            call hf1(21,real(amvec),1.)
            call hf1(22,real(ptvec),1.)
            call hf1(23,real(rapvec),1.)
            call hf1(24,real(ptvec),1.)
         endif

         if( IDPRUP.eq.100 ) then
            call hf1(31,real(amvec),weight)
            call hf1(32,real(ptvec),weight)
            call hf1(33,real(rapvec),weight)
            call hf1(34,real(ptvec),weight)
         elseif( IDPRUP.eq.101 ) then
            call hf1(41,real(amvec),weight)
            call hf1(42,real(ptvec),weight)
            call hf1(43,real(rapvec),weight)
            call hf1(44,real(ptvec),weight)
         endif

         if( IDUP(ivec).gt.0 ) then
            call hf1(51,real(rapvec),weight)
         else
            call hf1(52,real(rapvec),weight)
         endif

C  leptonic decays
         if( ilep.gt.0 ) then
            il= ilep
            in= ineu
            idlep= IDUP(il)
            ptlep= sqrt( PUP(1,il)**2 +PUP(2,il)**2 )
            plep= sqrt( PUP(1,il)**2 +PUP(2,il)**2 +PUP(3,il)**2 )
            etalep= log( ( plep +abs( PUP(3,il) ) )/ptlep )
            if( PUP(3,il).lt.0.d0 ) etalep= -etalep
            call hf1(60,real(ptlep),weight)
            call hf1(61,real(etalep),weight)
            if( IDPRUP.eq.100 ) then
               call hf1(62,real(ptlep),weight)
               call hf1(63,real(etalep),weight)
            elseif( IDPRUP.eq.101 ) then
               call hf1(64,real(ptlep),weight)
               call hf1(65,real(etalep),weight)
            endif
            if( idlep.lt.0 ) then
               call hf1(66,real(ptlep),weight)
               call hf1(67,real(etalep),weight)
            else
               call hf1(68,real(ptlep),weight)
               call hf1(69,real(etalep),weight)
            endif
            ptneu= sqrt( PUP(1,in)**2 +PUP(2,in)**2 )
            amt2= 2.d0*( ptlep*ptneu
     >           -PUP(1,il)*PUP(1,in) -PUP(2,il)*PUP(2,in) )
            amt= 0.d0
            if( amt2.gt.0.d0 ) amt= sqrt( amt2 )
            call hf1(70,real(ptneu),weight)
            call hf1(71,real(amt),weight)
            if( IDPRUP.eq.100 ) then
               call hf1(72,real(amt),weight)
            elseif( IDPRUP.eq.101 ) then
               call hf1(73,real(amt),weight)
            endif
         endif

      ENDDO

      WRITE(*,'(/8X,''########## Event generation completed ##########''
     >     )')
      print *,'Total number of failure returns from PSKINI',
     >     nfail_pskini
      print *,'Do not warry unless too large; e.g., more than 1%.'
      print *,''

C  Summary
      print *,' '
      print *,'---------- Summary ----------'
      xabs= SUMXSEC
      print '('' Integrated absolute cross section = '',E12.6,
     >     '' pb'')', xabs
      print '(F10.0,'' positive, and '',F10.0,
     >     '' negative weight events'')', evpos,evneg
      evtot= evpos +evneg
      evdif= evpos -evneg
      rneg= evneg/evtot
      rnegerr= sqrt( ( 1.d0 -rneg )*rneg/evtot )
      print '(F10.0,'' events in total'')', evtot
      print '('' Negative weight fraction = '',F10.6,'' +- '',F10.6)', 
     >     rneg,rnegerr
      xsec= xabs*evdif/evtot
      xerr= xabs * 2.d0*rnegerr
      print '('' True cross section = '',E12.6,'' +-'',E12.6
     >     '' pb'')', xsec,xerr
      print *,'The error does not include the error from BASES/SPRING.'
      print *,'-----------------------------'

C...Histograms.
      call histdo
C
C -- Store histograms.
C
      if( flhist(1:1).NE.'*' ) then
        call hrput(0,flhist,'N')
      endif

      stop
      END
