C  _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
C _/_/  Set User Defined Energy Scale   _/_/
C_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
      SUBROUTINE GRCUSRSETQ
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'grchad.inc'
      INCLUDE 'inclm.h'
C...User-defined energy scale.
C
C   The definition is effective only when "ICOUP" or "IFACT" = 6.
C   Users must set their-defined energy scale into "GRCQ" or "GRCFAQ".
C
C...4-momentum in the CM frame of the hard interaction
C   PGRC(i,j)  (i=1,4:(px,py,pz,E)): 4-momentum of j-th particle.
C   PQGRC(i,j) (i=1,4:(px,py,pz,E)): 4-momentum of j-th resonance particle.

      call setscale( igsub, pgrc, grcq, grcfaq )

      RETURN
      END
C------------------------------------------------------------------------
      subroutine setscale( igsub, p, qren, qfac )
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'inclm.h'
      real*8 p(4,10)
      parameter ( qmin= 10.d0 )

      qren= qmin
      qfac= qmin

      if( ( igsub.ge.100 .and. igsub.le.104 )
     >     .or. ( igsub.ge.421 .and. igsub.le.451 ) ) then
         qren= AMW
         qfac= AMW
      endif

      return
      end
C------------------------------------------------------------------------
      subroutine scale_fsr( scale )
C  Return the FSR scale.
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'grchad.inc'

      scale= GRCFAQ

      RETURN
      END
C------------------------------------------------------------------------
      subroutine scale_fsub( igsub, p, scale )
C  Return the energy scale used in the final-state LLL subtraction.
      IMPLICIT REAL*8(A-H,O-Z)
      real*8 p(4,10)

      call setscale( igsub, p, qren, qfac )
      scale= qfac

      RETURN
      END
C  _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
C _/_/  Set User Defined Cut  _/_/
C_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
      SUBROUTINE GRCUSRCUT(IUSRCUT)
      IMPLICIT NONE
      INCLUDE 'grchad.inc'
      INTEGER IUSRCUT
      INTEGER GRCKFCD
      EXTERNAL GRCKFCD
      DOUBLE PRECISION GRCIVMS,GRCDPHI,GRCDRCN
      EXTERNAL GRCIVMS,GRCDPHI,GRCDRCN
C...User-defined kinematic cuts.
C
C   The returned argument is "IUSRCUT".
C   If events pass their cuts, IUSRCUT = 0,
C         not pass             IUSRCUT = 1.
C
C   Users must carefully check the convergence of the BASES iteration 
C   if they define a tight cut using this subroutine.
C
C...4-momentum in the CM frame of the hard interaction
C     PGRC(I,J)  (I=1,4:(px,py,pz,E))  : 4-momentum of J-th particle.
C
C...4-momentum in the Laboratory frame.
C     PLGRC(I,J) (I=1,4:(pT,phi,eta,E)): 4-momentum of J-th (J > 2) 
C                                        final state particle.
C
C...Useful stuff.
C     FUNCTION GRCKFCD(I)   : Output particle identification code.
C     FUNCTION GRCIVMS(I,J) : Output inv. mass between "I" and "J" particles.
C     FUNCTION GRCDPHI(I,J) : Output Delta Phi between "I" and "J" particles.
C     FUNCTION GRCDRCN(I,J) : Output Delta R between "I" and "J" particles.
C
C...Initialzation.
      IUSRCUT = 0
 
      RETURN
      END
 
C//////////////////////////////////////////
C  Laboratory frame cut inside "FUNC".
C  To be calles when "labcut" = 1.
C//////////////////////////////////////////
      subroutine grclabcut( icut )
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

      icut= 0

      return
      end
