      PROGRAM Pythia
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

      INTEGER PYK,PYCHGE,PYCOMP
C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Standard PYTHIA commonblocks.
      INTEGER N,NPAD,K
      REAL*8 P,V
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      INTEGER MSTU,MSTJ
      REAL*8 PARU,PARJ
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      INTEGER MDCY,MDME,KFDP
      REAL*8 BRAT
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      INTEGER MSEL,MSELPD,MSUB,KFIN
      REAL*8 CKIN
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      INTEGER MSTP,MSTI
      REAL*8 PARP,PARI
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

      character*80 lhafile

      parameter ( lhcom = 100000 )
      real*4 h
      common /pawc/h(lhcom)
      character*72 flhist
      real*4 weight

      integer ilep0(2),ilep(2)

C-----------------------------------------------------------------------
C  Output hbook file; "*" for no output.
C-----------------------------------------------------------------------
C      flhist= '*'
      flhist= 'hist.hbook'
C-----------------------------------------------------------------------
C  Number of events. 
C-----------------------------------------------------------------------
      NEV = 9999999                 ! Number of events
C-----------------------------------------------------------------------
C  PS/MI choice in Pythia.
C-----------------------------------------------------------------------
C      MSTP(61)  = 0   ! no ISR
C      MSTP(71)  = 0   ! no FSR
C      MSTP(81)  = 0   ! no MI, old PS when PYEVNT called
C      MSTP(81)  = 1   ! MI on, old PS when PYEVNT called (default)
C      MSTP(81)  = 20  ! no MI, new PS (= PYEVNW)
C      MSTP(81)  = 21  ! MI on, new PS (= PYEVNW)
C      MSTP(111) = 0   ! no hadronization
C-----------------------------------------------------------------------
C  Reset the energy-scale factor
C-----------------------------------------------------------------------
C  The default value of PARP(67) for the "old" PS is not suitable.
C  Comment out when the "new" PS is chosen.
      PARP(67)= 1.0    ! ISR energy scale factor for the "old" PS.
      PARP(71)= 1.0    ! FSR energy scale factor.
C-----------------------------------------------------------------------
C   PDF choice
C-----------------------------------------------------------------------
C      mstp(51)= 1         ! CTEQ3L
C      mstp(51)= 4         ! GRV 94L
C      mstp(51)= 7         ! CTEQ5L (default)
C      mstp(51)= 11        ! GRV 92L
C      mstp(51)= 12        ! EHLQ set 1
C      mstp(58)= 5         ! Nr. of flavor in PDF 
C-----------------------------------------------------------------------
C  Initialization
C-----------------------------------------------------------------------
C  UPINIT is called in PYINIT.
      CALL PYINIT('USER',' ',' ',0,0d0)
C-----------------------------------------------------------------------
C  Print out the parameters
C-----------------------------------------------------------------------
C  Basic control
      print *,'PS, multiple-interaction, hadronization:'
      print *,'  mstp(61, 71, 81, 111) =',mstp(61),mstp(71),
     >     mstp(81),mstp(111)
      print *,'PDF choice: mstp(51) =',mstp(51),
     >     ' with NF: mstp(58) =',mstp(58)

C  Energy scale factors
      print *,'Energy scale factors:'
      print '(5X,''parp(67), parp(71) ='',2F10.3)', parp(67),parp(71)

C  Multiple interaction
      print *,'Multiple interaction model: mstp(82) = ',mstp(82)
      print '(5X,''parp(82) ='',F10.3)', parp(82)
      print '(5X,''parp(83), parp(84) ='',2F10.3)', parp(83),parp(84)
      print '(5X,''parp(85), parp(86) ='',2F10.3)', parp(85),parp(86)
      print '(5X,''parp(89), parp(90) ='',2F10.3)', parp(89),parp(90)

C  Primordial kT
      print *,'Primordial kT mode: mstp(91) = ',mstp(91)
      print '(5X,''parp(91), parp(93) = '',2F10.3)',parp(91),parp(93)

C...Book histograms.
      call hlimit(lhcom)

      call hbook1(1,'mass of V$',100,0.,200.,0.)
      call hbook1(2,'pt of V$',100,0.,200.,0.)
      call hbook1(3,'rapidity of V$',100,-10.,10.,0.)
      call hbook1(4,'pt of V; fine$',100,0.,20.,0.)

      call hbook1(11,'mass of V (pos)$',100,0.,200.,0.)
      call hbook1(12,'pt of V (pos)$',100,0.,200.,0.)
      call hbook1(13,'rapidity of V (pos)$',100,-10.,10.,0.)
      call hbook1(14,'pt of V; fine (pos)$',100,0.,20.,0.)

      call hbook1(21,'mass of V (neg)$',100,0.,200.,0.)
      call hbook1(22,'pt of V (neg)$',100,0.,200.,0.)
      call hbook1(23,'rapidity of V (neg)$',100,-10.,10.,0.)
      call hbook1(24,'pt of V; fine (neg)$',100,0.,20.,0.)

      call hbook1(31,'mass of V; non-rad$',100,0.,200.,0.)
      call hbook1(32,'pt of V; non-rad$',100,0.,200.,0.)
      call hbook1(33,'rapidity of V; non-rad$',100,-10.,10.,0.)
      call hbook1(34,'pt of V; fine; non-rad$',100,0.,20.,0.)

      call hbook1(41,'mass of V; rad$',100,0.,200.,0.)
      call hbook1(42,'pt of V; rad$',100,0.,200.,0.)
      call hbook1(43,'rapidity of V; rad$',100,-10.,10.,0.)
      call hbook1(44,'pt of V; fine; rad$',100,0.,20.,0.)

      call hbook1(60,'pt of lepton$',100,0.,100.,0.)
      call hbook1(61,'eta of lepton$',100,-10.,10.,0.)
      call hbook1(62,'pt of lepton; non-rad$',100,0.,100.,0.)
      call hbook1(63,'eta of lepton; non-rad$',100,-10.,10.,0.)
      call hbook1(64,'pt of lepton; rad$',100,0.,100.,0.)
      call hbook1(65,'eta of lepton; rad$',100,-10.,10.,0.)
      call hbook1(66,'pt of l+$',100,0.,100.,0.)
      call hbook1(67,'eta of l+$',100,-10.,10.,0.)
      call hbook1(68,'pt of l-$',100,0.,100.,0.)
      call hbook1(69,'eta of l-$',100,-10.,10.,0.)

      call hbook1(100,'Num. of particles$',100,0.,100.,0.)
      call hbook1(101,'Num. of ISR jets$',100,0.,100.,0.)
      call hbook1(102,'Num. of FSR jets$',100,0.,100.,0.)

C  Integrated absolute cross section.
      xabs= 0.d0
      do i=1,NPRUP
         xabs= xabs +XSECUP(i)
      enddo

      evpos= 0.d0
      evneg= 0.d0

C...Event loop.
      DO IEV = 1,NEV

C  Event processing.
C  UPEVNT is called in PYEVNT; then, the PS and decay simulations are done 
C  according the parameter choice.
         CALL PYEVNT
         if( MSTI(51).ne.0 ) then
            print *,'MSTI(51) = ',MSTI(51)
            print *,'-> EOD signal from PYEVNT'
            goto 9000
         endif

         if( IEV.le.2 ) then
            print *,''
            print *,'Event# ',IEV
            CALL PYLIST(1)
         elseif( mod(IEV,10000).eq.0 ) then
            print *,'Event# ',IEV
         endif

         if( XWGTUP.ge.0.d0 ) then
            weight= 1.
            evpos= evpos +1.d0
         else
            weight= -1.
            evneg= evneg +1.d0
         endif

C  Analysis
C (input data)
         nisr= 0
         nfsr= 0
         do i=1,NUP
            if( ISTUP(i).eq.1 .and. MOTHUP(1,i).le.2 .and. 
     >           MOTHUP(2,i).eq.0 ) nisr= nisr +1
            if( ISTUP(i).eq.1 .and. MOTHUP(1,i).eq.1 .and. 
     >           MOTHUP(2,i).eq.2 ) nfsr= nfsr +1
         enddo
         call hf1(100,NUP+.5,1.)
         call hf1(101,nisr+.5,1.)
         call hf1(102,nfsr+.5,1.)

C  (after PYTHIA)
C   Number of records for documentation
         do i=1,n
            if( K(i,1).ne.21 ) then
               ndoc= i -1
               goto 1
            endif
         enddo
 1       continue

C   Search the Z boson and leptons in the documentation.
         ivec0= 0
         nlep= 0
         ilep0(1)= 0
         ilep0(2)= 0
         do i=1,ndoc
            idabs= iabs( K(i,2) )
            if( idabs.eq.23 ) then
               ivec0= i
            elseif( idabs.eq.11 .or. idabs.eq.13 ) then
               nlep= nlep +1
               if( nlep.le.2 ) ilep0(nlep)= i
            endif
         enddo
         if( ivec0.lt.1 ) then
            print *,'No vector boson in the documentation.'
            stop
         endif

C   Search the W boson and leptons in the real record.
         ivec= 0
         ilep(1)= ilep0(1)
         ilep(2)= ilep0(2)
         do i=ndoc+1,n
            idabs= iabs( K(i,2) )
            imoth= K(i,3)
            if( idabs.eq.23 ) then
               ivec= i
            endif
            if( nlep.gt.0 ) then
               if( idabs.eq.11 .or. idabs.eq.13 ) then
                  if( imoth.eq.ilep(1) ) ilep(1)= i
                  if( imoth.eq.ilep(2) ) ilep(2)= i
               endif
            endif
         enddo
         if( ivec.lt.1 ) then
            print *,'No vector boson in the real record.'
            CALL PYLIST(1)
            stop
         endif

C  Properties of W.
         amvec= PYP( ivec, 5 )
         ptvec= PYP( ivec, 10 )
         rapvec= PYP( ivec, 17 )
         call hf1(1,real(amvec),weight)
         call hf1(2,real(ptvec),weight)
         call hf1(3,real(rapvec),weight)
         call hf1(4,real(ptvec),weight)
         if( weight.ge.0. ) then
            call hf1(11,real(amvec),1.)
            call hf1(12,real(ptvec),1.)
            call hf1(13,real(rapvec),1.)
            call hf1(14,real(ptvec),1.)
         else
            call hf1(21,real(amvec),1.)
            call hf1(22,real(ptvec),1.)
            call hf1(23,real(rapvec),1.)
            call hf1(24,real(ptvec),1.)
         endif

         if( IDPRUP.eq.110 ) then
            call hf1(31,real(amvec),weight)
            call hf1(32,real(ptvec),weight)
            call hf1(33,real(rapvec),weight)
            call hf1(34,real(ptvec),weight)
         elseif( IDPRUP.eq.111 ) then
            call hf1(41,real(amvec),weight)
            call hf1(42,real(ptvec),weight)
            call hf1(43,real(rapvec),weight)
            call hf1(44,real(ptvec),weight)
         endif

C  Decay leptons.
         if( nlep.gt.0 ) then
            do i=1,nlep
               il= ilep(i)
               idlep= K(il,2)
               ptlep= PYP( il, 10 )
               etalep= PYP( il, 19 )
               call hf1(60,real(ptlep),weight)
               call hf1(61,real(etalep),weight)
               if( IDPRUP.eq.110 ) then
                  call hf1(62,real(ptlep),weight)
                  call hf1(63,real(etalep),weight)
               elseif( IDPRUP.eq.111 ) then
                  call hf1(64,real(ptlep),weight)
                  call hf1(65,real(etalep),weight)
               endif
               if( idlep.lt.0 ) then
                  call hf1(66,real(ptlep),weight)
                  call hf1(67,real(etalep),weight)
               else
                  call hf1(68,real(ptlep),weight)
                  call hf1(69,real(etalep),weight)
               endif
            enddo
         endif

C...End of loop over events.
      ENDDO

 9000 continue

C...Cross section table.
      CALL PYSTAT(1)

C  Summary
      print *,' '
      print *,'---------- Summary ----------'
      print '('' Integrated absolute cross section = '',E12.6,
     >     '' pb'')', xabs
      print '(F10.0,'' positive, and '',F10.0,
     >     '' negative weight events'')', evpos,evneg
      evtot= evpos +evneg
      evdif= evpos -evneg
      rneg= evneg/evtot
      rnegerr= sqrt( ( 1.d0 -rneg )*rneg/evtot )
      print '(F10.0,'' events in total'')', evtot
      print '('' Negative weight fraction = '',F10.6,'' +- '',F10.6)', 
     >     rneg,rnegerr
      xsec= xabs*evdif/evtot
      xerr= xabs * 2.d0*rnegerr
      print '('' True cross section = '',E12.6,'' +-'',E12.6
     >     '' pb'')', xsec,xerr
      print *,'The error does not include the error from BASES/SPRING.'
      print *,'-----------------------------'

C...Histograms.
      call histdo
C
C -- Store histograms.
C
      if( flhist(1:1).NE.'*' ) then
        call hrput(0,flhist,'N')
      endif

      stop
      END

      SUBROUTINE UPINIT
C  An "LhaExt" version of UPINIT.
C
C  This routine opens a data file, reads in the "run information" from the 
C  header records, and skips siecified number of events.
C  LUNs for the control file and the data file, and other control parameters 
C  must be given in a read-control file named "lharead_control.txt".
C
C  June 8, 2004, S. Odaka (KEK)
      IMPLICIT NONE

      integer lunctl,lundat,ifmt
      common /lharead/lunctl,lundat,ifmt

      character*80 lhactl
      parameter ( lhactl= 'lharead_control.txt' )
      integer lun,idwt,nSkip,iev
      integer lun1,lun2

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

      print *,' '
      print *,'============================== UPINIT =====',
     >     '=================================='

C  Open the control file.
      lun= 10
      call lunfind( lun )
      lunctl= lun
      open(lunctl,file=lhactl,status='OLD')
      print '('' LHA control file opened: LUN = '',I3)',lunctl
      print '(''   file name = '',A80)',lhactl

C  Read the 1st line: LUNs for the control file and the data file.
      read(lunctl,*) lun1,lun2
      if( lun1.ge.1 ) then
         close( lunctl )
         lunctl= lun1
         print '('' LUN for the control file reassigned: LUN = '',
     >        I3)',lunctl
         open(lunctl,file=lhactl,status='OLD')
         read(lunctl,*) lun1
      endif

C  Read the 2nd line: the parameter for the weighting strategy.
      read(lunctl,*) idwt
      print '('' Specified weighting strategy = '',I3)',idwt
      if( idwt.eq.0 ) then
         print *,'   -> no overwrite'
      else
         print *,'   -> overwrite'
      endif

C  Read the 3rd line: number of events to skip.
      read(lunctl,*) nSkip
      print '('' First '',I3,'' events will be skipped.'')',nSkip

C  Open the 1st data file.
      if( lun2.ge.1 ) then
         lundat= lun2
      else
         call lunfind( lun )
         lundat= lun
      endif
      print '('' Input data file: LUN = '',I3)',lundat

      call lhaopen( lunctl, lundat, ifmt, *9 )

C  Update the run information.
      print *,'Read the header record'
      if( ifmt.eq.0 ) then
         call lhaReadHdAsc( lundat, 0 )
      elseif( ifmt.eq.1 ) then
         call lhaReadHdBin( lundat, 0 )
      endif

C  Overwrite the weighting strategy parameter if specified.
      if( idwt.ne.0 ) IDWTUP= idwt
      print '('' -> weighting strategy = '',I3)',IDWTUP

C  Skip specified number of events.
      if( nSkip.gt.0 ) then
         do iev=1,nSkip
            call lhaReadEvnt(lunctl,lundat,ifmt,*8)
         enddo
         print '('' First '',I3,'' events skipped.'')',nSkip
      endif

      print *,'===========================================',
     >     '=================================='

      return

 8    continue
      print *,'End-of-data during the event skip -> stop'
      stop

 9    continue
      print *,'(error) no input-data file given'
      stop

      end

      subroutine lunfind( lun )
      integer lun
      logical lopen

 1    inquire( lun, opened=lopen )
      if( lopen ) then
         lun= lun +1
         goto 1
      endif

      return
      end

      subroutine lhaopen( lunctl, lundat, ifmt, * )

      character*10 filefmt
      character*80 filename

C  Read the information for the 1st data file.
      call lhactlrd( lunctl, filefmt, filename, *9 )
      print '('' New input file: format = '',A10)',filefmt
      print '(''   file name = '',A80)',filename

C  Open the 1st data file.
      if( filefmt(1:3).eq.'asc' ) then
         ifmt= 0
         open(lundat,file=filename,form='FORMATTED',status='OLD')
      elseif( filefmt(1:3).eq.'bin' ) then
         ifmt= 1
         open(lundat,file=filename,form='UNFORMATTED',status='OLD')
      endif

      print *,'   -> successfully opened'

      return

 9    return 1

      end

      subroutine lhactlrd( lunctl, filefmt, filename, * )

      character*10 filefmt
      character*80 filename
      character*80 string

 1    read(lunctl,'(A80)',end=9) string
C      print *,'Input string:'
C      print '(A80)',string

      if( string(1:1).eq.'*' ) goto 1
      if( string(1:4).eq.'end ' .or. string(1:4).eq.'End '
     >     .or. string(1:4).eq.'END ' ) goto 9

      isep= 0
      do i=1,80
         isep= isep +1
         if( string(isep:isep).eq.':' ) goto 2
      enddo
      print *,'LHACTLRD (error): no separator in the control list'
      stop

 2    continue
      filefmt= string(1:isep-1)
      filename= string(isep+1:80)

      return

 9    continue
      print *,'LHACTLRD: end of the control list'
      return 1

      end

      SUBROUTINE UPEVNT
C  An "LhaExt" version of UPEVNT.
C
C  This routine reads in one event from a data file.
C  The actual read action is done by "lhaReadEvnt".
C  The end-of-data of the input is signaled to the calling routine by
C  setting NUP = 0.
C
C  June 8, 2004, S. Odaka (KEK)
      IMPLICIT NONE

      integer lunctl,lundat,ifmt
      common /lharead/lunctl,lundat,ifmt

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

C  Read an event record.
      call lhaReadEvnt(lunctl,lundat,ifmt,*9)

      return

C  No more file to read.
 9    continue
      NUP= 0
      return

      END
